/********************************************************************************/
/* Name			: Quarantine.java										*/
/* Copyright	: 2006 DATA INFOCOM LTD.				     			*/
/* Team			: Spam Control Team										*/
/* Developer	: Kishan Kumar Meena									*/
/* Last Updated	: 10/02/2006											*/
/* Abstract		: Java Bean for Update and Delete Quarantine mail list	*/
/* Called from	: quarantine.jsp			 							*/
/* Calls		: n														*/
/********************************************************************************/
package com.antispam;

import com.DBConnection;
import java.net.*;
import java.io.*;

public class Quarantine
{
	DBConnection dbconn = new DBConnection ();

	public String recid = "";
	public String alias_addr = "";
	public int userid = 0;

	public String flag = "";
	public String sessionid="";
	public String mailerid ="";
	public String mailerdomain = "";
	public String flagasl = "";
	public String flagaslid = "";

	
	/* SET-GET THE Record ID */
	public void setFlagasl ( String id )
	{	  
		flagasl = id;
	}
	public String getFlagasl ( )
	{
		return flagasl;      
	}

	/* SET-GET THE Record ID */
	public void setFlagaslid ( String id )
	{	  
		flagaslid = id;
	}
	public String getFlagaslid ( )
	{
		return flagaslid;      
	}
	/* SET-GET THE Record ID */
	public void setSessionid ( String id )
	{	  
		sessionid = id;
	}
	public String getSessionid ( )
	{
		return sessionid;      
	}

	/* SET-GET THE Record ID */
	public void setRecid ( String id )
	{	  
		recid = id;
	}
	public String getRecid ( )
	{
		return recid;      
	}

	/* SET-GET THE USER ID */
	public void setUserid ( int newuserid )
	{
		userid = newuserid;
	}
	public int getUserid ( )
	{
		return userid;
	}
	
	public void setFlag( String s )
	{
		flag = s;
	}
	public String getFlag()
	{
		return flag;
	}


	public String registered ( ) 
	{
		String retVal = "";
		      
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
		java.sql.ResultSet rs = null;
		PrintWriter out = null;
		BufferedReader in = null;

		String qry = null;
		String falgexist = "";
		String serverRes = "";

		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();

			if ( flag.equals("MOVE") )
			{
				//Connection server at port 25 for moving email 
				qry="select ip,id from quarantine where id='"+recid+"'";
				rs = smt.executeQuery(qry);
				rs.next();
				InetAddress addr=InetAddress.getByName(rs.getString(1));
				Socket socket = new Socket(addr,25);
				in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
				out = new PrintWriter(socket.getOutputStream(),true);
				out.println("#FORWARD#"+rs.getString(2));
				serverRes = in.readLine();
				
				
	
				if(! serverRes.startsWith("220"))
				{
					retVal = "Server Bussy, Please Try After Some Time";
					return retVal;
				}
				else
				{
					serverRes = in.readLine();
				}
				
				if(serverRes.startsWith("250"))
				{
					qry = "update quarantine set flag='a' where id='"+recid+"'";
					smt.executeUpdate(qry);
					retVal = "Mail moved to inbox Successfully";
				}
				else if(serverRes.startsWith("550"))
				{
					retVal = serverRes;
				}
			}
			else if(flag.equals("DELETE"))
			{
				qry = "update quarantine set flag='d' where id='"+recid+"'";
				smt.executeUpdate(qry);
				retVal = "Mail Deleted from Quarantine Successfully";
			}
			else if(flag.equals("DELETE ALL"))
			{
				qry = "update quarantine set flag='d' where to_id=(select to_id from quarantine where session_id='"+sessionid+"' limit 1)";
				smt.executeUpdate(qry);
				retVal = "All Mails Are Deleted from Quarantine Successfully";
			}
			
				if(flagasl.equals("UPDATEPOLICY"))
				{
						qry = "SELECT to_id from quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						qry = "select userid from users where email_username='"+rs.getString(1).substring(0,rs.getString(1).indexOf("@"))+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						userid = Integer.parseInt(rs.getString(1));
						qry = "SELECT from_id FROM quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						mailerid = rs.getString(1).substring(0,rs.getString(1).indexOf("@"));
						mailerdomain = rs.getString(1).substring(rs.getString(1).indexOf("@")+1,rs.getString(1).length());
						qry = "SELECT MAILERID,MAILERDOMAIN FROM ASL WHERE MailerID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"' and userid="+userid;
						rs = smt.executeQuery(qry);
						if(! rs.next())
						{
							qry = "INSERT INTO ASL(USERID,MAILERID,MAILERDOMAIN,DATE_OF_ENTRY,CONDITIONID,APPROVALID) VALUES("+userid+", '"+mailerid+"', '"+mailerdomain+"', now(), "+Integer.parseInt(flagaslid)+", "+1+")";
							smt.executeUpdate(qry);
							retVal = retVal+" E-Mail address is added to list.";
						}
						else
						{
							qry = "UPDATE ASL SET CONDITIONID="+Integer.parseInt(flagaslid)+" where USERID="+userid+" and MAILERID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"'";
							smt.executeUpdate(qry);
							retVal = retVal+" Email address policy is updated.";
						}

				}
				else if(flagasl.equals("UPDATESCOPE"))
				{
						qry = "SELECT to_id from quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						qry = "select userid from users where email_username='"+rs.getString(1).substring(0,rs.getString(1).indexOf("@"))+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						userid = Integer.parseInt(rs.getString(1));
						qry = "SELECT from_id FROM quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						mailerid = rs.getString(1).substring(0,rs.getString(1).indexOf("@"));
						mailerdomain = rs.getString(1).substring(rs.getString(1).indexOf("@")+1,rs.getString(1).length());
						qry = "SELECT MAILERID,MAILERDOMAIN FROM ASL WHERE MailerID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"' and userid="+userid;
						rs = smt.executeQuery(qry);
						if(! rs.next())
						{
							qry = "INSERT INTO ASL(USERID,MAILERID,MAILERDOMAIN,DATE_OF_ENTRY,CONDITIONID,APPROVALID) VALUES("+userid+", '"+mailerid+"', '"+mailerdomain+"', now(), "+1+", "+Integer.parseInt(flagaslid)+")";
							smt.executeUpdate(qry);
							retVal = retVal+". And E-Mail is added to pre-approved list.";
						}
						else
						{
							qry = "UPDATE ASL SET CONDITIONID="+Integer.parseInt(flagaslid)+" where USERID="+userid+" and MAILERID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"'";
							smt.executeUpdate(qry);
							retVal = retVal+" Email address scope is updated.";
						}
				
				}else if(flagasl.equals("UPDATESPAM"))
				{
						qry = "SELECT to_id from quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						qry = "select userid from users where email_username='"+rs.getString(1).substring(0,rs.getString(1).indexOf("@"))+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						userid = Integer.parseInt(rs.getString(1));
						qry = "SELECT from_id FROM quarantine where id='"+recid+"'";
						rs = smt.executeQuery(qry);
						rs.next();

						mailerid = rs.getString(1).substring(0,rs.getString(1).indexOf("@"));
						mailerdomain = rs.getString(1).substring(rs.getString(1).indexOf("@")+1,rs.getString(1).length());
						qry = "SELECT MAILERID,MAILERDOMAIN FROM ASL WHERE MailerID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"' and userid="+userid;
						rs = smt.executeQuery(qry);
						if(! rs.next())
						{
							qry = "INSERT INTO ASL(USERID,MAILERID,MAILERDOMAIN,DATE_OF_ENTRY,CONDITIONID,APPROVALID) VALUES("+userid+", '"+mailerid+"', '"+mailerdomain+"', now(), "+2+", "+Integer.parseInt(flagaslid)+")";
							smt.executeUpdate(qry);
							retVal = retVal+". And E-Mail is added to pre-approved list as SPAM.";
						}
						else
						{
							qry = "UPDATE ASL SET conditionid=2 where USERID="+userid+" and MAILERID='"+mailerid+"' and MAILERDOMAIN='"+mailerdomain+"'";
							smt.executeUpdate(qry);
							retVal = retVal+" Email address scope is updated.";
						}
				
				}

			
			
		}
		catch ( java.sql.SQLException sqle )
		{
			System.out.println("SQLE Exception-->"+sqle);
			sqle.printStackTrace();
			retVal=sqle.toString();
		}
		catch ( java.net.ConnectException jce )
		{
			System.out.println("Connection Exception-->"+jce);
			retVal="Server Bussy, Please Try After Some Time";
		}
		catch ( Exception e )
		{
			System.out.println("Exception-->"+e);
			retVal=e.toString();
		}
		finally
		{
			try 
			{
				smt.close();
				conn.close();
			}
			catch ( Exception ignored ) {}
		}
		return retVal;
	}
}
