package taglibrary;

import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
import java.net.*;
import java.util.Date;
import java.text.SimpleDateFormat;
import com.DBConnection;
import java.util.List;
import java.util.LinkedList;

public class DomainIncomingLog extends BodyTagSupport
{
	public String dname = "";
	public int domainid = 0;	
	public String txtfrom = "";
	public String txtto = "";
	public String txtDatefrom = "";
	public String txtDateTo = "";
	public String txtemail = "";	
	private String order = "";
	private String column = "";
	public String tabtype = "";
	public String dateFormat = "";
	
	public int recordlimit = 0;

	int txtnumrec = 0;
	public int minimum = 0;		
	public int maximum = 0;
	public int k =0;
	
	private  List EmailID = new LinkedList();		
	private  List Date_Recv = new LinkedList();
	private  List Client_IP= new LinkedList();
	private  List e_from = new LinkedList();
	private  List e_toaddr = new LinkedList();
	private  List e_status = new LinkedList();
	private  List ToDomain = new LinkedList();
	private  List FromDomain = new LinkedList();
	private  List ErrorMsg = new LinkedList();
	private  List Expr1 = new LinkedList();
	
	private int index;
	private StringBuffer output = null;

	DBConnection dbconn = new DBConnection ();
   /////////
	public void setMinimum( int d )
    	{
		minimum = d;	
	}
	
	public int getMinimum()
    	{	
		return minimum;	
	}
	/////////
	public void setTxtfrom( String d )
    	{
		txtfrom = d;	
	}
	
	public String getTxtfrom()
    	{	
		return txtfrom;	
	}
	/////////
	public void setTxtto( String d )
    	{
		txtto = d;	
	}
	
	public String getTxtto()
    	{	
		return txtto;	
	}
	/////////
	public void setTxtDatefrom( String d )
    	{
		txtDatefrom = d;	
	}
	
	public String getTxtDatefrom()
    	{	
		return txtDatefrom;	
	}
	/////////
	public void setTxtDateTo( String d )
    	{
		txtDateTo = d;	
	}
	
	public String getTxtDateTo()
    	{	
		return txtDateTo;	
	}
	/////////
	public void setTxtemail( String d )
    	{
		txtemail = d;	
	}
	
	public String getTxtemail()
    	{	
		return txtemail;	
	}

	// GET-SET METHOD FOR ORDER OF RECORDS (ASCENDING/ DESCENDING)
	public String getOrder ()
    {	
		return order;	
	}
    public void setOrder( String neworder )
    {
		this.order = neworder;	
	}

	// GET-SET METHOD FOR COLUMN NAME TO BE SORT
	public String getColumn ()
    {	
		return column;	
	}
    public void setColumn( String newcolumn )
    {
		this.column = newcolumn;	
	}
	
	//SET-GET DOMAINID	 
	public void setDomainid( int d )
    	{
		domainid = d;	
	}
	
	public int getDomainid ()
    	{	
		return domainid;	
	}

	public void setTabtype( String d )
    	{
		tabtype = d;	
	}
	
	public String getTabtype ()
    	{	
		return tabtype;	
	}
	

	//SET-GET RECORD LIMIT	 
	public void setRecordlimit( int d )
    	{
		recordlimit = d;	
	}
	
	public int getRecordlimit ()
    {
		return recordlimit;	
	}

	/////////
	public void setTxtNumRec( int d )
    {
		txtnumrec = d;	
	}
	
	public int getTxtNumRec()
    {	
		return txtnumrec;	
	}
	/////////

	public int doStartTag() throws JspException
	{
		java.sql.Connection conn = null;
		java.sql.Statement stmt = null;
		java.sql.Statement stmt_dformat = null;
		java.sql.ResultSet rs = null;
		java.sql.ResultSet rsdomain = null;
		java.sql.ResultSet rs_dformat = null;

		output = new StringBuffer();
		String flag = "true";
		String qry = null;
		String qrydomain = null;
		k = 0;
		
		try
		{
			conn = dbconn.getConnection();
			stmt = conn.createStatement();
			stmt_dformat = conn.createStatement();
			
			///Adding code to get User Define Date format
			rs_dformat = stmt_dformat.executeQuery("select date_format from admindefaults");
			rs_dformat.next();
			dateFormat = rs_dformat.getString("date_format");
			rs_dformat.close();
			stmt_dformat.close();
			//End of Date format code now dateFormat is replaced in the query
			
			//FETCH LOG RECORDS FROM INCOMINGLOG TABLE 
			qry = "SELECT EmailID,to_char(Date_recv,'"+dateFormat+" hh24:mi'),Client_IP,e_from,e_toaddr,e_status,ToDomain,FromDomain,ErrorMsg FROM INCOMINGLOG";
			
			if(!txtfrom.equals("*"))
			{
				if(txtfrom.startsWith("*"))
					txtfrom = txtfrom.substring(1);
				if(txtfrom.endsWith("*"))
					txtfrom = txtfrom.substring(0,txtfrom.length() - 1);

				if(!flag.equals("true"))
				{
					qry = qry +  " AND e_from like '%"+txtfrom+"%'";
				}
				else
				{
					qry = qry +  " WHERE e_from like '%"+txtfrom+"%'";	
					flag="false";	
				}		
			}		
			
			if(!txtto.equals("*"))
			{
				if(txtto.startsWith("*"))
					txtto = txtto.substring(1);
				if(txtto.endsWith("*"))
					txtto = txtto.substring(0,txtto.length() - 1);

				if(!flag.equals("true"))
				{
					qry = qry +  " AND e_toaddr like '%"+txtto+"%'";
				}
				else
				{
					qry = qry +  " WHERE e_toaddr like '%"+txtto+"%'";	
					flag="false";	
				}	
			}		
			if(!txtDatefrom.equals("*"))
			{
				if(!flag.equals("true"))
					//qry = qry +  " AND Date_Recv >= to_date('"+txtDatefrom+"','MM/DD/YYYY hh:mm')";
					qry = qry +  " AND Date_Recv >= to_timestamp('"+txtDatefrom+"','dd/MM/yyyy hh24:mi')";
				else
				{
					//qry = qry +  " WHERE Date_Recv >= to_date('"+txtDatefrom+"','MM/DD/YYYY hh:mm')";
					qry = qry +  " WHERE Date_Recv >= to_timestamp('"+txtDatefrom+"','dd/MM/yyyy hh24:mi')";
					flag="false";	
				}	
			}
			if(!txtDateTo.equals("*"))
			{
				if(!flag.equals("true"))
				{
					if(!txtDatefrom.equals("*"))
						//qry = qry +  " AND Date_Recv <= to_date('"+txtDateTo+"', 'MM/DD/YYYY hh:mm')+1";
						qry = qry +  " AND Date_Recv <= to_timestamp('"+txtDateTo+"', 'dd/MM/yyyy hh24:mi')";
					else
						qry = qry +  " AND (to_timestamp(to_char(Date_Recv, 'dd/MM/yyyy hh24:mi'), 'DD/MM/YYYY hh:mm') <= to_timestamp('"+txtDateTo+"', 'MM/dd/yyyy hh24:mi'))";
				}
				else
				{
					qry = qry +  " WHERE (to_timestamp(to_timestamp(Date_Recv,'dd/MM/yyyy hh24:mi'), 'DD/MM/YYYY hh:mm') <= to_timestamp('"+txtDateTo+"','MM/dd/yyyy hh24:mi'))";
					flag="false";	
				}	
			}
								
			if(!txtemail.equals("*"))
			{
				if(txtemail.startsWith("*"))
					txtemail = txtemail.substring(1);
				if(txtemail.endsWith("*"))
					txtemail = txtemail.substring(0,txtemail.length() - 1);

				if(!flag.equals("true"))
				{
					qry = qry +  " AND EmailID like '%"+txtemail+"%'";
				}
				else
				{
					qry = qry +  " WHERE EmailID like '%"+txtemail+"%'";	
					flag="false";	
				}	
			}	
			
			if(tabtype.equalsIgnoreCase("domain"))
			{
				qrydomain = "select domainname from domains where domainid ="+domainid ;	
				rsdomain = stmt.executeQuery( qrydomain );

				if(rsdomain.next())
				{
					dname = rsdomain.getString(1);	
				}
				qry = qry +" and todomain='"+dname+"'";
			}
	
			qry = qry +" order by "+column+" "+order+ " LIMIT "+recordlimit;
			rs = stmt.executeQuery( qry );
			
			if ( rs.next() )
			{
				int i = 0;
				int j = 0;
				k++;
								
				while(i<(minimum-1) && rs.next())
				{
					i++;
					k++;
				}	

				do
				{
					EmailID.add ( rs.getString( 1 ) );
					Date_Recv.add ( rs.getString( 2 ));
					Client_IP.add ( rs.getString( 3 ) );
					e_from.add ( rs.getString( 4 ) );
					e_toaddr.add ( rs.getString( 5 ) );
					e_status.add(rs.getString( 6 ));
					ToDomain.add(rs.getString( 7 ));
					FromDomain.add(rs.getString( 8 ));
					ErrorMsg.add(rs.getString( 9 ));
					
					j++;
					k++;
				}
				while(rs.next() && j < getTxtNumRec());

				while(rs.next())
				{
					k++;
				}
			}
			else
			{
				EmailID.add ("0");
				Date_Recv.add("0");
				Client_IP.add ("0" );
				e_from.add ("0");
				e_toaddr.add ( "0");
				e_status.add ( "0");	
				ToDomain.add ("0");
				FromDomain.add ( "0");
				ErrorMsg.add ( "0");
			}
		}
		catch ( java.sql.SQLException sqle )
		{	
				System.out.println("SQLE Exception-->"+sqle+"qry="+qry);
				EmailID.add ("0");
				Date_Recv.add("0");
				Client_IP.add ("0" );
				e_from.add ("0");
				e_toaddr.add ( "0");
				e_status.add ( "0");	
				ToDomain.add ("0");
				FromDomain.add ( "0");
				ErrorMsg.add ( "0");
		}
		catch ( Exception e )
		{	
				EmailID.add ("0");
				Date_Recv.add("0");
				Client_IP.add ("0" );
				e_from.add ("0");
				e_toaddr.add ( "0");
				e_status.add ( "0");	
				ToDomain.add ("0");
				FromDomain.add ( "0");
				ErrorMsg.add ( "0");
				System.out.println("Exception-->"+e+"qry="+qry);	
		}
		finally
		{
			try
			{	
				rs.close();
				stmt.close();
				conn.close();
			}
			catch ( Exception ignored ) {System.out.println("Spam Controllar");
			System.out.println(ignored);
			}
		}
		if ( EmailID.size() > 0 )
		{
			setLoopVariables();
			return EVAL_BODY_TAG;
		}
		return SKIP_BODY;
	}

	public int doAfterBody() throws JspTagException
    {
		BodyContent bodyContent = getBodyContent();
		if ( bodyContent != null )
		{
			output.append( bodyContent.getString() );
			try
			{
				bodyContent.clear();
			}
			catch ( IOException ex )
			{
				System.out.println("Spam Controllar");
                throw new JspTagException("Fatal IO Error");
			}
		}
		if ( ++index < EmailID.size() )
		{
			setLoopVariables();
			return EVAL_BODY_TAG;
		}
		
		return SKIP_BODY;
     }

	public int doEndTag() throws JspTagException
	{
		try
		{
			bodyContent.getEnclosingWriter().write( output.toString() );
		}
		catch ( IOException ex )
		{
			System.out.println("Error -->"+ex);
			throw new JspTagException("Fatal IO Error");
		}
		pageContext.setAttribute( "Expr1", new Integer(k));    
		return EVAL_PAGE;
	}
    
	private void setLoopVariables ()
    {
		pageContext.setAttribute( "EmailID", EmailID.get( index ).toString() );
		pageContext.setAttribute( "Date_Recv", Date_Recv.get( index ).toString() );
		pageContext.setAttribute( "Client_IP", Client_IP.get( index ).toString() );
		pageContext.setAttribute( "e_from",e_from.get( index ).toString() );
		pageContext.setAttribute( "e_toaddr", e_toaddr.get( index ).toString() );
	    pageContext.setAttribute( "e_status", e_status.get( index ).toString() );
		pageContext.setAttribute( "ToDomain",ToDomain.get( index ).toString() );
		pageContext.setAttribute( "FromDomain", FromDomain.get( index ).toString() );
	    pageContext.setAttribute( "ErrorMsg", ErrorMsg.get( index ).toString() );    
	}
}