 /******************************************************************************/
/* Name		:Paging.java													*/
/* Copyright		:2003 SATCOMLABS LTD.											*/
/* Team		:Spam Control Team												*/
/* Developer		:Pavan Gupta														*/
/* Last Updated	:2.45 PM 08/01/2004											*/
/* Abstract		:										*/
/* Called from	:dashboard														*/
/* Calls		:																*/
/********************************************************************************/
package taglibrary;

import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.io.*;
import java.net.*;

public class Paging extends TagSupport
{
	private int totalrecords = 0;
	private int minpage = 0;
	private int min = 0;
	public int minimum = 0;	
	public String clicked = "";
	public int txtnumrec = 0;

	private String pagingtype = "";

	public int gettoTalrecords ()
	{	
		return totalrecords;	
	}
    public void setTotalrecords( int s )
    {
		totalrecords = s;	
	}

	public int getMinpage ()
	{	
		return minpage;	
	}
    public void setMinpage( int s )
    {
		minpage = s;	
	}

	public int getMin ()
	{	
		return min;	
	}
    public void setMin( int s )
    {
		min = s;	
	}

	public String getPagingtype ()
	{	
		return pagingtype;	
	}
    public void setPagingtype( String s )
    {
		pagingtype = s;	
	}

	 /////////
	public void setMinimum( int d )
    	{
		minimum = d;	
	}
	
	public int getMinimum()
    	{	
		return minimum;	
	}
	/////////

	/////////
	public void setClicked( String d )
    	{
		clicked = d;	
	}
	
	public String getClicked()
    	{	
		return clicked;
	}
	/////////

	/////////
	public void setTxtNumRec( int d )
    {
		txtnumrec = d;	
	}
	
	public int getTxtNumRec()
    {	
		return txtnumrec;	
	}
	/////////


	public int doStartTag() throws JspException
    {
		try
		{
			JspWriter out = pageContext.getOut();
			int pageincoming = totalrecords/10;
			int pageincomingleft = totalrecords%10;
			if(pageincomingleft > 0)
				pageincoming = pageincoming + 1;
			int pageno = 0;
			int leftpage = pageincoming-minpage;
			
				if (minpage >=getTxtNumRec()) 
				{
					out.println("<a href=javascript:onclick=changePage('"+(minpage-getTxtNumRec())+"','"+(min - 100)+"','"+pagingtype+"')>...</a>");
				} 
				if( leftpage >=getTxtNumRec()) 
				{
					for(pageno=minpage+1; pageno<=minpage+getTxtNumRec(); pageno++)
					{
						out.println("<a href=javascript:onclick=Page('"+min+"','"+(min+(getTxtNumRec()-1))+"','"+pagingtype+"')>"+pageno+"</a>");
						min = min+getTxtNumRec();
					}
					out.println("<a href=javascript:onclick=changePage('"+(pageno-1)+"','"+min+"','"+pagingtype+"')>...</a>");
				}
				else
				{
					for(pageno=minpage+1; pageno<=minpage+leftpage; pageno++)
					{
						if(!getClicked().equals(""))
						{
							if(getMinimum()==getMin() && getClicked().equals(getPagingtype()))
							{
								out.println("<font color='#FF0000'>"+pageno+"</font>");
								min = min+getTxtNumRec();
										
							}
							else
							{
								out.println("<a href=javascript:onclick=Page('"+min+"','"+(min+(getTxtNumRec()-1))+"','"+pagingtype+"')>"+pageno+"</a>");
								min = min+getTxtNumRec();
							}
						}
						else
						{
							if(getMinimum()==getMin())
							{
								out.println("<font color='#FF0000'>"+pageno+"</font>");
								min = min+getTxtNumRec();	
							}
							else
							{
								out.println("<a href=javascript:onclick=Page('"+min+"','"+(min+(getTxtNumRec()-1))+"','"+pagingtype+"')>"+pageno+"</a>");
								min = min+getTxtNumRec();
							}
						}
					}
				}
		}
		catch ( Exception e )
		{
			System.out.println("Exception-->"+e);	
		}
		return SKIP_BODY;
	}
}	