<%
/********************************************************************************/
/* Name			:	editadminasl.jsp											*/
/* Copyright	:	2003 SATCOMLABS LTD.										*/
/* Team			:	Spam Control Team											*/
/* Developer	:	Pavan Gupta													*/
/* Last Updated	:	22/01/2004													*/
/* Abstract		:	Update and delete records in ADMINASL table					*/
/* Called from	: 	servermain.jsp.jsp, serverviewall.jsp						*/
/* Calls		:	ServerAddWhiteList.class									*/
/********************************************************************************/
%>
<jsp:useBean id = "validate" scope="session" class="com.antispam.Authentication" />
<jsp:useBean id = "addwhitelist" scope="page" class="com.antispam.ServerAddWhiteList" />

<%
int userid = validate.getUserid();
String flag = request.getParameter("flag");
%>
<jsp:setProperty name="addwhitelist" property="flag" value=<%= flag %> />
<%
String returnval = "";
int condition = 0;
String val = "";
if(request.getParameter("val")!= null)
	val = request.getParameter("val");
else 
	val = "";

if(request.getParameter("conditionid") != null)
	condition = Integer.parseInt(request.getParameter("conditionid"));

int approvalid = 0;
int conditionid = 0;
int aslid = 0;

//GETTING SCOPE OF EMAIL ADDRESS
if(flag.equals("UPDATESCOPE"))
{
	if(request.getParameter("cmdScope").equals("E"))
		approvalid = 1;
	if(request.getParameter("cmdScope").equals("D"))
		approvalid = 2;
	if(request.getParameter("cmdScope").equals("S"))
		approvalid = 3;
}

//GETTING CONDITION TYPE OF EMAIL ADDRESS
else if(flag.equals("UPDATEPOLICY"))
{
	if(request.getParameter("cmdPolicy").equals("P"))
		conditionid = 1;
	if(request.getParameter("cmdPolicy").equals("S"))
		conditionid = 2;
}

if(request.getParameter("aslid") != null)
	aslid = Integer.parseInt(request.getParameter("aslid"));
%>
<!--SETTING ALL THE REQUIRED VALUES -->
<jsp:setProperty name="addwhitelist" property="approvalid" value="<%= approvalid %>" />
<jsp:setProperty name="addwhitelist" property="conditionid" value="<%= conditionid %>" />
<jsp:setProperty name="addwhitelist" property="aslid" value="<%= aslid %>" />
<%
	if(val.equals("all"))
	{
		if(flag.equals("DELETE"))
		{
			String arraslid[] = request.getParameterValues("chkdelete");
			for(int i=0; i<arraslid.length; i++)
			{
%>
<jsp:setProperty name="addwhitelist" property="aslid" value="<%= arraslid[i] %>" />
<%
				returnval = addwhitelist.registered();
			}
			response.sendRedirect("serverviewall.jsp?conditionid="+condition+"&msg="+returnval);
		}
		else if(flag.equals("UPDATE"))
		{
			int arrapprovalid = 0;
			int arrconditionid = 0;
			String arraslid[]=request.getParameterValues("txtid");
			int recordcount = Integer.parseInt(request.getParameter("txtcount"));
			for(int i=1; i<=recordcount; i++)
			{
				arrconditionid = Integer.parseInt(request.getParameter("optpolicy"+i));
				arrapprovalid = Integer.parseInt(request.getParameter("optscope"+i));
%>
<jsp:setProperty name="addwhitelist" property="aslid" value="<%= arraslid[i-1] %>" />
<jsp:setProperty name="addwhitelist" property="approvalid" value="<%= arrapprovalid %>" />
<jsp:setProperty name="addwhitelist" property="conditionid" value="<%= arrconditionid %>" />
<%
				returnval = addwhitelist.registered();
			}
			response.sendRedirect("serverviewall.jsp?conditionid="+condition+"&msg="+returnval);
		}
	}

	else if(val.equals("selected"))
	{
		String type = request.getParameter("type");
		String flag1 = request.getParameter("flag1");
		String txtsearch = request.getParameter("txtsearch");
		String rdoPolicy = request.getParameter("rdoPolicy");
		String rdoScope = request.getParameter("rdoScope");
		String txtAfter = request.getParameter("txtAfter");
		String txtBefore = request.getParameter("txtBefore");

		if(flag.equals("DELETE"))
		{
			String arraslid[] = request.getParameterValues("chkdelete");
			for(int i=0; i<arraslid.length; i++)
			{
%>
<jsp:setProperty name="addwhitelist" property="aslid" value="<%= arraslid[i] %>" />
<%
				returnval = addwhitelist.registered();
			}
		}
		else if(flag.equals("UPDATE"))
		{
			int mincount = 0;
			int recordcount = 0;
			int arrapprovalid = 0;
			int arrconditionid = 0;
			String arraslid[]=request.getParameterValues("txtid");
	
			if(request.getParameter("type").equals("updateany"))
			{
				mincount = Integer.parseInt(request.getParameter("txtmincount"))+1;
				recordcount = Integer.parseInt(request.getParameter("txtcount"));
			}
			else if(request.getParameter("type").equals("updatepre"))
			{
				mincount = Integer.parseInt(request.getParameter("txtmincount1"))+1;
				recordcount = Integer.parseInt(request.getParameter("txtcount1"));
			}
			else if(request.getParameter("type").equals("updatespam"))
			{
				mincount = Integer.parseInt(request.getParameter("txtmincount2"))+1;
				recordcount = Integer.parseInt(request.getParameter("txtcount2"));
			}
			for(int i=mincount; i<=recordcount; i++)
			{
				arrconditionid = Integer.parseInt(request.getParameter("optpolicy"+i));
				arrapprovalid = Integer.parseInt(request.getParameter("optscope"+i));
%>
			<jsp:setProperty name="addwhitelist" property="aslid" value="<%= arraslid[i-1] %>" />
			<jsp:setProperty name="addwhitelist" property="approvalid" value="<%= arrapprovalid %>" />
			<jsp:setProperty name="addwhitelist" property="conditionid" value="<%= arrconditionid %>" />
<%
				returnval = addwhitelist.registered();
			}
		}
		response.sendRedirect("servercustomview.jsp?flag1="+flag1+"&txtsearch="+txtsearch+"&rdoPolicy="+rdoPolicy+"&rdoScope="+rdoScope+"&txtAfter="+txtAfter+"&txtBefore="+txtBefore+"&msg="+returnval+"&update_type="+type);
	}


	else
	{
		String flag1 = request.getParameter("flag1");
		String searchtext = "";
		if(request.getParameter("txtSearch") !=null)
			searchtext = request.getParameter("txtSearch");
		else
			searchtext = "";
		returnval = addwhitelist.registered();
		response.sendRedirect("servermain.jsp?flag1="+flag1+"&txtSearch="+searchtext);
	}
%>
