/********************************************************************************/
/* Name			:User.java														*/
/* Copyright	:2003 SATCOMLABS LTD.											*/
/* Team			:Spam Control Team												*/
/* Developer	:Pavan Gupta / Manzar Imam										*/
/* Last Updated	:1.05 PM 10/01/2004												*/
/* Abstract		:Bean for Update and Insert user Settings						*/
/* Called from	:usersettings.jsp, usersettingstemp.jsp							*/
/* Calls		:																*/
/********************************************************************************/
package com.antispam;

import java.net.*;
import java.io.*;
import com.DBConnection;
import com.replace.Replace;
import com.antispam.TimeTools;
//import com.SocketConnection;


public class User
{
	DBConnection dbconn = new DBConnection ();
	Replace rep = new Replace ();
	Email email = new Email ();
	TimeTools timetool = new TimeTools();
	// SocketConnection socketconn =new SocketConnection();

	private boolean registered = false;

	public String domain = "";
	public String user_reg = "";
	private String pop3_ip = "";
	private String full_addr = "";
	public String txtfname = "";		// FIRST NAME
	public String txtlname = "";		// LAST NAME
	public String txtemail = "";
	public String txtpwd = "";
	public int domainid = 0;
	public int status = 0;
	public int passivestatus = 0;
	public int keymails = 0;
	public int adminid = 0;
	public int approve = 0;
	public int allwd_exp_keymails = 0;
	public int allwd_lmt_keymails = 0;
	public int allwd_dsb_keymails = 0;
	public String txtsubject = "";
	public String txtmaxu = "";
	public String txtbody = "";
	public String txtchallenge = "";
	public String txtapproval = "";
	public String txtalready = "";
	public String txtfailed = "";
	public String txtcomments = "";
	public String txtCarbonCopy = "";
	public String txtAlternateEmail = "";
	public String tempid = "";
	public String temppassword = "";
	public String tempflag = "";
	public String txtAlternateto="";
	public String cmbdate = "";
	public String hidsendalsochallenge = "";
	public String cmbRevdns = "";
	public String hidquarantined = "";
	public String domain_quarantine_time ="";
	public String domain_passive_text = "";
	public String passiveflag = "";

    int maxuser =0;
	int total= 0;

	String retVal = "0";
	      
	java.sql.Connection conn = null;
	java.sql.Statement smt = null;
	java.sql.ResultSet rs = null;
	String qry = null;


	//private String fullmailid;		// Like shivraj@antispam.dil.in
	public String flag = "";

	/* SET-GET  the passive challange mail flag*/
      public void setPassiveflag ( String s )
      {	  passiveflag = s;      }
      public String getPassiveflag ( )
      {	  return passiveflag;      }

	/* SET-GET for Getting Quarantine time in domain */
     public void setPassiveText(String s)
	{ domain_passive_text = s;}

	 public String getPassiveText()
	{ return domain_passive_text;}

	/* SET-GET for Getting Quarantine time in domain */
     public void setQuarantinetime(String s)
	{ domain_quarantine_time = s;}

	 public String getQuarantinetime()
	{ return domain_quarantine_time;}

	/* SET-GET  Grey list challange Mail*/
      public void setHidsendalsochallenge ( String s )
      {	 hidsendalsochallenge = s;}
	      
	public String getHidsendalsochallenge( )
      { return hidsendalsochallenge;  }

	/* SET-GET  quarantined Flag*/
      public void setQuaranstatus ( String s )
      {	 hidquarantined = s;}
	      
	public String getQuaranstatus( )
      { return hidquarantined;  }

	/* SET-GET  Date Format*/
      public void setCmbdate ( String s )
      {	 cmbdate = s; }
	     public String getCmbdate( )
      {  return cmbdate;  }


	/* SET-GET THE FIRST NAME */
	public void setTxtfname ( String s )
	{	  txtfname = s;      }
	public String getTxtfname ( )
	{	  return txtfname;      }

	/* SET-GET THE LAST NAME */
	public void setTxtlname ( String s )
	{	  txtlname = s;      }
	public String getTxtlname ( )
	{	  return txtlname;      }

	/* SET-GET THE EMAIL */
	public void setTxtemail ( String s )
	{
	  txtemail = s;
	  try
	  {
		  //txtemail = s.substring( 0, s.indexOf('@') );
		  domain = s.substring( s.indexOf('@') + 1 );
	  }
	  catch ( Exception e )
	  { }
	}
	public String getTxtemail ( )
	{	  return txtemail;      }

	/* SET-GET THE PASSWORD */
	public void setTxtpwd ( String s )
	{	txtpwd = s;	}
	public String getTxtpwd ( )
	{	return txtpwd;	}

	/* SET-GET THE DOMAIN ID */
	public void setDomainid ( int s )
	{	  domainid = s;      }
	public int getDomainid ( )
	{	  return domainid;      }

	
	/* SET-GET THE STATUS */
	public void setStatus ( int s )
	{	  status = s;      }
	public int getStatus ( )
	{	  return status;      }

	/* SET-GET THE PASSIVE STATUS */
	public void setPassivestatus ( int s )
	{	  passivestatus = s;      }
	public int getPassivestatus ( )
	{	  return passivestatus;      }

	
    /* SET-GET THE KEYMAILS */
	public void setKeymails ( int s )
	{	  keymails = s;      }
	public int getKeymails ( )
	{	  return keymails;      }

	/* SET-GET THE ADMIN ID */
	public void setAdminid ( int s )
	{	  adminid = s;      }
	public int getAdminid ( )
	{	  return adminid;      }

	/* SET-GET THE AUTO ADD */
	public void setApprove ( int s )
	{	  approve = s;      }
	public int getApprove ( )
	{	  return approve;      }

	/* SET-GET THE ALLOWEDEXPIREDKEYMAILS */
	public void setAllwd_exp_keymails ( int s )
	{	  allwd_exp_keymails = s;      }
	public int getAllwd_exp_keymails ( )
	{	  return allwd_exp_keymails;      }

	/* SET-GET THE ALLOWEDLIMITEDKEYMAILS */
	public void setAllwd_lmt_keymails ( int s )
	{	  allwd_lmt_keymails = s;      }
	public int getAllwd_lmt_keymails ( )
	{	  return allwd_lmt_keymails;      }

	/* SET-GET THE ALLOWEDDISABLEDKEYMAILS */
	public void setAllwd_dsb_keymails ( int s )
	{	  allwd_dsb_keymails = s;      }
	public int getAllwd_dsb_keymails ( )
	{	  return allwd_dsb_keymails;      }

	/* SET-GET THE EMAIL SUBJECT */
	public void setTxtsubject ( String s )
	{      txtsubject = s;      }
	public String getTxtsubject ( )
	{	  return txtsubject;      }

	/* SET-GET THE MAX USER IN A DOMAIN SUBJECT */
	public void setTxtmaxu ( String s )
	{      txtmaxu = s;      }
	public String getTxtmaxu ( )
	{	  return txtmaxu;      }

	/* SET-GET THE EMAIL BODY */
	public void setTxtbody ( String s )
	{	  txtbody = s;      }
	public String getTxtbody ( )
	{	  return txtbody;      }


	/* SET-GET THE CHALLENGE WEBPAGE */
	public void setTxtchallenge ( String s )
	{	  txtchallenge = s;      }
	public String getTxtchallenge ( )
	{	  return txtchallenge;      }

	/* SET-GET THE APPROVAL WEBPAGE */
	public void setTxtapproval ( String s )
	{	  txtapproval = s;      }
	public String getTxtapproval ( )
	{	  return txtapproval;      }

	/* SET-GET THE ALREADY IN WEBPAGE */
	public void setTxtalready ( String s )
	{	  txtalready = s;      }
	public String getTxtalready ( )
	{	  return txtalready;      }

	/* SET-GET THE FAILED WEBPAGE */
	public void setTxtfailed ( String s )
	{	  txtfailed = s;      }
	public String getTxtfailed ( )
	{	  return txtfailed;      }

	/* SET-GET THE COMMENTS */
	public void setTxtcomments ( String s )
	{	  txtcomments = s;      }
	public String getTxtcomments ( )
	{	  return txtcomments;      }

	/* SET-GET THE FORWARD EMAIL ADDRESS */
	public void setTxtCarbonCopy ( String s )
	{	  txtCarbonCopy = s;      }
	public String getTxtCarbonCopy ( )
	{	  return txtCarbonCopy;      }

	/* SET-GET THE ALTERNATE EMAIL ADDRESS */
	public void setTxtAlternateEmail ( String s )
	{	  txtAlternateEmail = s;      }
	public String getTxtAlternateEmail ( )
	{	  return txtAlternateEmail;      }

	public void setFlag( String s )
	{	flag = s;      }
	public String getFlag()
	{	  return flag;      }

	/* SET-GET THE TEMPORARY ID */
	public void setTempid ( String s )
	{	  tempid = s;      }
	public String getTempid ( )
	{	  return tempid;      }

	/* SET-GET THE TEMPORARY PASSWORD */
	public void setTemppassword( String s )
	{	temppassword = s;   }
	public String getTemppassword ( )
	{	  return temppassword;      }

	/* SET-GET THE TEMPORARY FlAG */
	public void setTempflag( String s )
	{	  tempflag = s;      }
	public String getTempflag ( )
	{	  return tempflag;      }

	/* SET-GET THE ALTERNATE EMAIL ADDRESS */
	public void setTxtAlternateto( String s )
	{	  txtAlternateto = s;      }
	public String getTxtAlternateto ( )
	{	  return txtAlternateto;      }

	 public void setCmbRevdns ( String s )
      {	
		  cmbRevdns = s;	  
	  }
	      
			public String getCmbRevdns( )
      {
		  return cmbRevdns;   
		  }
	public String maxusercheck( )
	{
		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();

			// check whether domain users max limit exceed
			qry = "SELECT DOMAINID FROM DOMAINS WHERE DOMAINNAME='"+domain+"' ";			
			rs = smt.executeQuery( qry );  
			if(rs.next())
			{
				domainid = rs.getInt( 1 );
			}

			qry = "select count(*) as maxuser from users where DOMAINID="+domainid;

			rs = smt.executeQuery( qry );  
			if(rs.next())
			{
				maxuser = rs.getInt( 1 );
			}

			qry = "select total_user from domains where DOMAINID="+domainid;
			rs = smt.executeQuery( qry ); 

			if( rs.next() )
			{				
				total = rs.getInt(1);
			}


			if( total != 0)
			{
				
				if((maxuser + 1) > total)
				{
					retVal = "Max Allowed user limit exceed in this domain";
					registered = false;
				
				}
				else  registered ( ) ;
			}
			else   registered ( ) ;


		}
		catch ( java.sql.SQLException sqle )
		{
			System.out.println("SQLE Exception-->"+sqle);
			retVal = "";
			registered = false; 
		}
		catch ( Exception e )
		{
			System.out.println("Exception-->"+e);
			registered = false;
			retVal = "";
		}
		finally
		{
			try {
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
		return retVal;
	}

	public String registered ( ) 
	{

		txtsubject = rep.replaceBy ( txtsubject, "'", "''" );
		txtmaxu = rep.replaceBy ( txtmaxu, "'" , "''" );
		txtbody = rep.replaceBy ( txtbody, "'", "''" );
		txtchallenge = rep.replaceBy ( txtchallenge, "'", "''" );
		txtapproval = rep.replaceBy ( txtapproval, "'", "''" );
		txtalready = rep.replaceBy ( txtalready, "'", "''" );
		txtfailed = rep.replaceBy ( txtfailed, "'", "''" );
		txtcomments = rep.replaceBy ( txtcomments, "'", "''" );

		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();
			
			if ( flag.equals("UPDATE") )
			{
				qry = "UPDATE USERS SET "+
				"FirstName = '"+txtfname+"', "+
				"LastName = '"+txtlname+"', "+
				"Status = "+status+", "+
				"AdminID = "+adminid+", "+
				"AutoAdd = '"+approve+"', "+
				"allowexpiredkeymails = "+allwd_exp_keymails+", "+
				"allowlimitedkeymails = "+allwd_lmt_keymails+", "+
				"allowdisabledkeymails = "+allwd_dsb_keymails+", "+
				"EmailSubject = '"+txtsubject+"', "+
				"EmailBody = '"+txtbody+"', "+
				"challengeWebPage = '"+txtchallenge+"', "+
				"approvalWebPage = '"+txtapproval+"', "+
				"alreadyInWebPage = '"+txtalready+"', "+
				"FailedWebPage = '"+txtfailed+"', "+
				"Comments = '"+txtcomments+"', "+
				"Alternate_email = '"+txtCarbonCopy+"', "+
				"passivestatus = "+passivestatus+", "+
				"keymails = "+keymails+", "+
				"alternatefromemail = '"+txtAlternateEmail + "', alternateto='"+ txtAlternateto + "', challenge_flag ='"+hidsendalsochallenge+
				"',quarantined='"+hidquarantined+"',passiveflag='"+passiveflag+"' WHERE EMAIL_USERNAME = '"+ txtemail.substring(0, txtemail.indexOf('@')) +"' AND DOMAINID="+domainid;
			
				smt.executeUpdate ( qry );
				retVal = "Updated";		// 	Means the entry is updated sucessfully....
				//socketconn.listenSocket("UpdateUser:"+txtemail);
				
			}
			else
			{
				boolean domainExists = false;
				
				// check whether the domain exists in the table DOMAINS
				// if exists then get the domain id and the ANTIVIRUS_IP for that domain...
				qry = "SELECT DOMAINID, ANTIVIRUS_IP,FULL_ADDR,USER_REG FROM DOMAINS WHERE DOMAINNAME='"+domain+"' ";
				rs = smt.executeQuery( qry );
				if ( rs.next() )
				{
					domainExists = true;
					domainid = rs.getInt( 1 );
					pop3_ip = rs.getString( 2 );
					if(pop3_ip.indexOf(":") != -1)
						pop3_ip = pop3_ip.substring(0,pop3_ip.indexOf(":"));
	
					full_addr = rs.getString( 3 );
					user_reg= rs.getString( 4 );
				}
				else
				{
					domainExists = false;
					retVal = "Domain " + domain +" not exist";		//DOMAIN NOT EXIST
				}
				
				if ( rs != null )
					rs = null;


				
				// check whether the user with the specified domain and the username exists..
				boolean emailExists = false;
				if ( domainExists )
				{
					// check whether the mailid and the password given are correct or not ......
					String emailaddress = "";
					if(full_addr.equals("1"))
						emailaddress = txtemail.substring(0,txtemail.indexOf('@'));
					else if(full_addr.equals("0"))
						emailaddress = txtemail;

					if ( email.isEmailExists( emailaddress, txtpwd, pop3_ip) )
						emailExists = true;
					else
					{
						emailExists = false;
						retVal = txtemail + " mailid or password incorrect";		//EMAIL NOT EXIST
					}
				}
				
				boolean userExists = true;
					
				if ( emailExists )
				{
					qry = "SELECT USERID FROM USERS WHERE "+
						"EMAIL_USERNAME='"+txtemail.substring(0, txtemail.indexOf('@'))+"' AND DOMAINID="+domainid;
					rs = smt.executeQuery ( qry );
					
					if ( rs.next() )
					{
						userExists = true;
						retVal = txtemail + " already registered";		//ALREADY REGISTERED
					}
					else
						userExists = false;
				}
						
				if ( !userExists )
				{
					if( user_reg.equals("tempid"))
					{
						if(tempflag.equals("hide"))
						{
							setTempflag("show");
							retVal="";
						}
						else
						{
							boolean tempuserExists = false;
							String temppwd = "";
							java.util.Date signup_date = new java.util.Date();
							java.util.Date expirydate = new java.util.Date();

							qry = "SELECT TEMP_ID, TEMP_PWD, SIGNUP_ALLOWED, VALIDATION FROM TEMP_USER WHERE TEMP_ID = "+tempid+" AND  STATUS != 'true' and domainid="+domainid;
							rs = smt.executeQuery ( qry );
							if(rs.next())
							{
								temppwd = rs.getString(2);
								java.util.Date signup_allowed = rs.getDate(3);
								int validmonth = rs.getInt(4);
								expirydate = timetool.addMonthsToDate(expirydate,validmonth);

								if ( !temppwd.equals(temppassword) )
								{
									tempuserExists = false;
									retVal = "Incorrect Temporary Password";
								}
								else
								{
									if (signup_allowed.compareTo(signup_date) < 0)
									{
										tempuserExists = false;
										retVal = "Your SignUp Date is expired";
									}
									else
										tempuserExists = true;
								}
							}
							else 
							{
								tempuserExists = false;
								retVal = "Temporary Id does not Exist";
							}
							if( tempuserExists )
							{
								String email_subject = "";
								String email_body = "";
								String challenge_webpage = "";
								String approval_webpage = "";
								String alreadyin_webpage = "";
								String failed_webpage = "";
								String comments = "";
								qry = "SELECT DEFAULTEMAIL_SUBJECT, DEFAULTEMAIL_BODY, DEFAULTCHALLENGEWEBPAGE, DEFAULTAPPROVALWEBPAGE, DEFAULTALREADYINWEBPAGE, DEFAULTFAILEDWEBPAGE, COMMENTS FROM DOMAINS WHERE DOMAINID = "+domainid;
								rs = smt.executeQuery(qry);
								if(rs.next())
								{
									 email_subject = rep.replaceBy(rs.getString(1), "'", "''" );
									 email_body = rep.replaceBy(rs.getString(2), "'", "''" );
									 challenge_webpage = rep.replaceBy(rs.getString(3), "'", "''" );
									 approval_webpage = rep.replaceBy(rs.getString(4), "'", "''" );
									 alreadyin_webpage = rep.replaceBy(rs.getString(5), "'", "''" );
									 failed_webpage = rep.replaceBy(rs.getString(6), "'", "''" );
									 comments = rep.replaceBy(rs.getString(7), "'", "''" );
								}

								qry = "INSERT INTO USERS ( FIRSTNAME, LASTNAME, EMAIL_USERNAME, DOMAINID, STATUS, ADMINID, AUTOADD, ALLOWEXPIREDKEYMAILS, ALLOWLIMITEDKEYMAILS, ALLOWDISABLEDKEYMAILS, EMAILSUBJECT, EMAILBODY, CHALLENGEWEBPAGE, APPROVALWEBPAGE, ALREADYINWEBPAGE, FAILEDWEBPAGE, COMMENTS, ALTERNATE_EMAIL, PASSIVESTATUS, KEYMAILS, ALTERNATEFROMEMAIL,ALTERNATETO) VALUES('"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', '"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', '"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', "+domainid+", 1, 3,'0', "+allwd_exp_keymails+" , "+allwd_lmt_keymails+", "+allwd_dsb_keymails+", '"+email_subject+"', '"+email_body+"', '"+challenge_webpage+"', '"+approval_webpage+"', '"+alreadyin_webpage+"', '"+failed_webpage+"', '"+comments+"', '"+txtCarbonCopy+"', "+passivestatus+", "+keymails+",'"+txtAlternateEmail+"','"+txtAlternateto+"')";
								registered = true;
								smt.executeUpdate( qry );
                       			qry = "update temp_user set status = 'true', signup_dt=now(), signup_id = '"+ txtemail +"', expiry_dt='"+expirydate+"' where TEMP_ID = '"+tempid+"'";
								smt.executeUpdate(qry);
								//socketconn.listenSocket("AddUser:"+txtemail);
							}
						}
					}
					else
					{
						String email_subject = "";
						String email_body = "";
						String challenge_webpage = "";
						String approval_webpage = "";
						String alreadyin_webpage = "";
						String failed_webpage = "";
						String comments = "";
						qry = "SELECT DEFAULTEMAIL_SUBJECT, DEFAULTEMAIL_BODY, DEFAULTCHALLENGEWEBPAGE, DEFAULTAPPROVALWEBPAGE, DEFAULTALREADYINWEBPAGE, DEFAULTFAILEDWEBPAGE, COMMENTS FROM DOMAINS WHERE DOMAINID = "+domainid;
						rs = smt.executeQuery(qry);
						if(rs.next())
						{
							 email_subject = rep.replaceBy(rs.getString(1), "'", "''" );
							 email_body = rep.replaceBy(rs.getString(2), "'", "''" );
							 challenge_webpage = rep.replaceBy(rs.getString(3), "'", "''" );
							 approval_webpage = rep.replaceBy(rs.getString(4), "'", "''" );
							 alreadyin_webpage = rep.replaceBy(rs.getString(5), "'", "''" );
							 failed_webpage = rep.replaceBy(rs.getString(6), "'", "''" );
							 comments = rep.replaceBy(rs.getString(7), "'", "''" );
						}

						qry = "INSERT INTO USERS ( FIRSTNAME, LASTNAME, EMAIL_USERNAME, DOMAINID, STATUS, ADMINID, AUTOADD, ALLOWEXPIREDKEYMAILS, ALLOWLIMITEDKEYMAILS, ALLOWDISABLEDKEYMAILS, EMAILSUBJECT, EMAILBODY, CHALLENGEWEBPAGE, APPROVALWEBPAGE, ALREADYINWEBPAGE, FAILEDWEBPAGE, COMMENTS, ALTERNATE_EMAIL, PASSIVESTATUS, KEYMAILS, ALTERNATEFROMEMAIL,ALTERNATETO) VALUES('"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', '"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', '"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"', "+domainid+", 1, 3,'0', "+allwd_exp_keymails+" , "+allwd_lmt_keymails+", "+allwd_dsb_keymails+", '"+email_subject+"', '"+email_body+"', '"+challenge_webpage+"', '"+approval_webpage+"', '"+alreadyin_webpage+"', '"+failed_webpage+"', '"+comments+"', '"+txtCarbonCopy+"', "+passivestatus+", "+keymails+",'"+txtAlternateEmail+"','"+txtAlternateto+"')";
						registered = true;
						smt.executeUpdate( qry );
						//socketconn.listenSocket("AddUser:"+txtemail);
					}
				}
				else
					registered = false;
			}
		}
		catch ( java.sql.SQLException sqle )
		{
			System.out.println("SQLE Exception-->"+sqle);
			retVal = "";
			registered = false; 
		}
		catch ( Exception e )
		{
			System.out.println("Exception-->"+e);
			registered = false;
			retVal = "";
		}
		finally
		{
			try {
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
		return retVal;
	}


	public String validateCustomer( )
	{
		java.sql.Connection conn = null;
		java.sql.Statement smt = null;
		java.sql.ResultSet rs = null;
		String returnval = "nothing";

		try
		{
			conn = dbconn.getConnection();
			smt = conn.createStatement();
			String qry = null;

			if ( flag.equals("UPDATE") )
			{
				// The user is already registered and he is updating his profile...
				qry = "SELECT FirstName, LastName, Email_UserName, DomainID, Status, AdminID, AutoAdd, AllowExpiredkeymails, AllowLimitedkeymails, AllowDisabledkeymails, EmailSubject, EmailBody, challengeWebPage, approvalWebPage, alreadyInWebPage, FailedWebPage, Comments, alternate_email, passivestatus, keymails, alternatefromemail,alternateto,challenge_flag,quarantined,passiveflag FROM Users where LOWER(Email_UserName)='"+txtemail.substring(0, txtemail.indexOf('@')).toLowerCase()+"' AND DOMAINID="+domainid;
				rs = smt.executeQuery( qry );
				if ( rs.next() )
				{
					setTxtfname( rs.getString( 1 ) );
					setTxtlname(rs.getString( 2 ));
					setTxtemail( rs.getString( 3 ));
					setDomainid( rs.getInt( 4 ));
					setStatus( rs.getInt( 5 ));
					setAdminid(  rs.getInt( 6 ));
					String autoadd = rs.getString( 7 );
					setAllwd_exp_keymails( rs.getInt( 8 ));
					setAllwd_lmt_keymails( rs.getInt( 9 ));
					setAllwd_dsb_keymails(  rs.getInt( 10 ));
					setTxtsubject(  rs.getString( 11 ));
					setTxtbody(  rs.getString( 12 ));
					setTxtchallenge( rs.getString( 13 ));
					setTxtapproval( rs.getString( 14 ));
					setTxtalready(rs.getString( 15 ));
					setTxtfailed( rs.getString( 16 ));
					setTxtcomments( rs.getString( 17 ));
					setTxtCarbonCopy( rs.getString( 18 ));
					setPassivestatus( rs.getInt( 19 ));
					setKeymails( rs.getInt( 20 ));
					setTxtAlternateEmail( rs.getString( 21 ));
					setTxtAlternateto( rs.getString( 22 ));
					setHidsendalsochallenge( rs.getString( 23 ));
					setQuaranstatus(rs.getString(24));
					setApprove( Integer.parseInt(autoadd));
					setPassiveflag( rs.getString(25));
					registered=true;

					qry = "select ageing,passivetext from domains where domainid="+domainid;
				    rs = smt.executeQuery( qry );
					rs.next();
					setQuarantinetime(rs.getString(1));
					setPassiveText(rs.getString(2));
				}
				else
					registered=false;
			}
			else
			{
				// The user has registered First time....
				// Select The information from AdminDefaults Tables to get the default Values for
				// usersetting page.....
			
				qry = "SELECT DefaultEmail_Subject, DefaultEmail_Body, DefaultchallengeWebPage, DefaultapprovalWebPage, DefaultalreadyInWebPage, DefaultFailedWebPage, Max_Users, date_format,reverse_dns FROM AdminDefaults";

				rs = smt.executeQuery( qry );

				if ( rs.next() )
				{
					setTxtsubject(rs.getString(1));
					setTxtbody(rs.getString(2));
					setTxtchallenge(rs.getString(3));
					setTxtapproval(rs.getString(4));
					setTxtalready(rs.getString(5));
					setTxtfailed(rs.getString(6));
					setTxtmaxu(rs.getString(7));
					setCmbdate(rs.getString(8));
					setCmbRevdns(rs.getString(9));

					registered=true;
				}
				else
					registered=false;

				returnval = qry;
			}
		
		}
		catch ( java.sql.SQLException sqle )
		{	System.out.println("SQLE Exception-->"+sqle);	}
		catch ( Exception e )
		{	System.out.println("Exception-->"+e);	}
		finally
		{
			try
			{
				rs.close();
				smt.close();
				conn.close();
			} catch ( Exception ignored ) {}
		}
		return returnval;
	}
	  
	public boolean isRegistered ()
	{
		return registered;
	}
}
