<%
/********************************************************************************/
/* Name			: domainwhitelist.jsp											*/
/* Copyright	: 2003 SATCOMLABS LTD.											*/
/* Team			: Spam Control Team												*/
/* Developer	: Amit Kumar													*/
/* Last Updated	: 																*/
/* Abstract		: Add new email address to DomainASL Table						*/
/* Called from	: dashboardlogin.jsp											*/
/* Calls		:																*/
/********************************************************************************/
%>
<%@ taglib prefix="spam" uri="/WEB-INF/TLDS/spamcontrollar.tld" %>
<%@ taglib prefix="domain" uri="/WEB-INF/TLDS/domain.tld" %>
<jsp:useBean id = "conn" scope="page" class="com.DBConnection" />
<jsp:useBean id = "validate" scope="session" class="com.antispam.Authentication" />
<jsp:useBean id = "domainmainid" scope = "session" class = "com.antispam.DomainSettings" />

<%
java.sql.Connection con = null;
java.sql.Statement stmt = null;
java.sql.ResultSet rscount = null;
java.sql.ResultSet rstotaluser = null;

int totaluser = 0;
int count = 0;
String qry = "";

int userid = validate.getUserid();
String emailaddr = "";
%>
<spam:UserInfo userid="<%= userid %>">
  <% emailaddr = username +"@"+domainname; %>
</spam:UserInfo>
<%
//String emailaddr = validate.getTxtemail();

if(userid==0)
{
	response.sendRedirect("dashboardlogin.jsp");
}
else
{
int adminid = validate.getAdminid();


int logindomainid = validate.getDomainid();
int domainid = 0;
int tempdomainid = validate.getTempdomainid();
if(tempdomainid == 0)
	domainid = logindomainid;
else
	domainid = tempdomainid;

	domainmainid.setHiddomainid(domainid);
	domainmainid.registered();
	String user_reg = domainmainid.getRadRegistration();
	if(user_reg == null)
		user_reg = "";

String message = "";
if(request.getParameter("msg") != null)
	message = request.getParameter("msg");


try
{
	con = conn.getConnection();
	stmt = con.createStatement();

	qry = "select count(*) from temp_user where domainid = "+domainid;
	rscount = stmt.executeQuery(qry);
	if(rscount.next())
	{
		count = rscount.getInt(1);
	}
		
	qry = "select total_user from domains where domainid = "+domainid;
	rstotaluser = stmt.executeQuery(qry);
	if(rstotaluser.next())
	{
		String total_user = rstotaluser.getString(1);
		if (total_user == null)
			totaluser = 0;
		else
			totaluser = Integer.parseInt(total_user);
	}
}
catch ( java.sql.SQLException sqle )
{
	System.out.println("SQLE Exception-->"+sqle);	
}
catch ( Exception e )
{
	System.out.println("Exception-->"+e);	
}
finally
{
	try
	{
		stmt.close();
		con.close();
	}
	catch ( Exception ignored ) {System.out.println("Spam Controllar");}
}

%>

<HTML>
	<HEAD>
		<TITLE>Add to Whitelist</TITLE>
		<LINK href="stylesheets/display_control.css" rel=stylesheet type=text/css>
	</HEAD>

	<SCRIPT language=javascript src="scripts/web_uivalidation.js"></SCRIPT>
	<SCRIPT language=javascript src="scripts/validations.js"></SCRIPT>
	<SCRIPT language=javascript src="scripts/validate.js"></SCRIPT>
	<script language=javascript>
		
	//FUNCTION TO CHECK VALIDATION ON FIELD
		function chkValidation()
		{
			var no_tempid = parseInt(document.frmtempusers.txtid.value);
			var no_remainingid = parseInt(<%=totaluser-count%>);
			var no_totaluser = parseInt(<%=totaluser%>);
	
			if(isBlank(document.frmtempusers.txtsignup) == "1")
			{
				alert("SignUp Allowed Field cannot be blank");
				document.frmtempusers.txtsignup.focus();
				return false;
			}
			else if(spcharvalidate(document.frmtempusers.txtsignup.value,"/")==true)
			{
				alert("Speacial character found");
				document.frmtempusers.txtsignup.focus();
				
			}
			
			else if(isBlank(document.frmtempusers.txtid) == "1")
			{
				alert("Please Enter No. of Id's to Create");
				document.frmtempusers.txtid.focus();
				return false;
			}
			/*else if(spcharvalidate(document.frmtempusers.txtid.value,"/")==true)
			{
				alert("Speacial character found");
				document.frmtempusers.txtid.focus();
				
			}*/
			else if(isNaN(document.frmtempusers.txtid.value))
			{
				alert("Invalid value ! must be a number");
				document.frmtempusers.txtid.focus();
				return false;
			}
			else if(document.frmtempusers.txtid.value < 0)
			{
				alert("Invalid value ! must be a positive number");
				document.frmtempusers.txtid.focus();
				return false;
			}
			else if(no_totaluser != 0 && no_tempid > no_remainingid )
			{
				alert("Can't Create Temporary ID, Maximum Limit Exceeded");
				document.frmtempusers.txtid.focus();
				return false;
			}

			else if(isBlank(document.frmtempusers.txtemail) == "1")
			{
				alert("Email Address cannot be blank");
				document.frmtempusers.txtemail.focus();
				return false;
			}
			

			else if(emailcheck(document.frmtempusers.txtemail.value) == false)
			{
				document.frmtempusers.txtemail.value="";
				document.frmtempusers.txtemail.focus();
				return false;
			}
						
			else
			{
				document.frmtempusers.action="interdomaintempusers.jsp";
				document.frmtempusers.submit();
			}
		}

		//FUNCTION TO CHECK EMAIL ADDRESS
		function emailcheck(emailStr) 
		{
			var FormData=document.frmtempusers
			var dot=0
			var at2=0
			var at
		  
			var emailPat=/^(.+)@(.+)$/
			var specialChars="\\(\\)<>@,;:\\\\\\\"\\.\\[\\]"
			var validChars="\[^\\s" + specialChars + "\]"
			var quotedUser="(\"[^\"]*\")"
			var ipDomainPat=/^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/
			var atom=validChars + '+'
			var word="(" + atom + "|" + quotedUser + ")"
			var userPat=new RegExp("^" + word + "(\\." + word + ")*$")
			var domainPat=new RegExp("^" + atom + "(\\." + atom +")*$")

			var matchArray=emailStr.match(emailPat)
			if (matchArray==null) 
			{
				alert("Email address seems incorrect (check @ and .'s)")
				return false
			}
			var user=matchArray[1]
			var domain=matchArray[2]
			if (user.match(userPat)==null) 
			{
				alert("The username doesn't seem to be valid.")
				document.frmtempusers.txtemail.focus();
					return false
			}
				var IPArray=domain.match(ipDomainPat)
			if (IPArray!=null) 
			{
				for (var i=1;i<=4;i++) 
				{
					if (IPArray[i]>255) 
					{
						alert("Destination IP address is invalid!")
						return false
					}
				}
				return true
			}

			var domainArray=domain.match(domainPat)

			if (domainArray==null) 
			{
				alert("The domain name doesn't seem to be valid.")
				document.frmtempusers.txtemail.focus();
				return false
			}

			var atomPat=new RegExp(atom,"g")
			var domArr=domain.match(atomPat)
			var len=domArr.length
			
			if (domArr[domArr.length-1].length<2)
			{
				alert("Invalid domain, it must be a two letter country or ore more than two letter domain.")
				return false;
			}

			if (len<2) 
			{
				var errStr="This address is missing a hostname!"
				alert(errStr)
				return false;
			}
		}

		function funload()
		{
			document.frmtempusers.cbovalidmonth.focus();
		}

		function fundate()
		{
			
			var dt = new Date();
			var dd = dt.getDate();
			var mm = dt.getMonth();
			var yy = dt.getFullYear();
	
			mm = (mm + 4);
			
			if(mm > 12 )
			{
				mm=(mm-12);
				yy = yy + 1;
			}

			document.frmtempusers.txtsignup.value = (dd+"/"+mm+"/"+yy);			

		}

	</script>

	<BODY onload="funload()">
		<FORM  method=post name=frmtempusers onsubmit="chkValidation();return false">
		<input type=hidden name=hiddomainid value='<%=domainid%>'>
		<input type=hidden name=hidemailid value='<%=emailaddr%>'>

			<INPUT type=hidden name=flag value="ADD">
			<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
				<TBODY>
					<TR>
						<TD colSpan=2><!--for the header Image-->
							<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
								<TBODY>
									<TR>
										<TD bgColor=#cecece>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
													<TR>
														<TD align=left vAlign=top width="52%"><img border="0" src="images/img.gif" width="436" height="48"></TD>
														<TD align=right vAlign=top width="48%"><IMG src="images/topbar-right.gif" width="229" height="48"></TD>
													</TR>
												</TBODY>
											</TABLE>
										</TD>
									</TR>
									<TR>
										<TD bgColor=#000000><IMG height=1 src="Add to Whitelist_files/1x1.gif" width=1></TD>
									</TR>
									<TR>
										<TD align=left bgColor=#007ccd height=37 vAlign=bottom>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
													<TR>
<!-- FOR SERVER ADMINISTRATOR ADMINID = 1 -->
													<% if (adminid == 1) { %>
														<TD align=left vAlign=bottom width="33%">
															<DIV class=header id=TopBanner_UserPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href="usermain.jsp">User</TD>
																			<TD align=right width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="33%">
															<DIV class=header_active id=TopBanner_DomainPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href="domainmain.jsp">Domain</TD>
																			<TD width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="34%">
															<DIV class=header id=TopBanner_ServerPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href="servermain.jsp">Server</TD>
																			<TD width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
<!-- FOR DOMAIN ADMINISTRATOR ADMINID = 2 -->
													<% } else if (adminid == 2) { %>
														<TD align=left vAlign=bottom width="33%">
															<DIV class=header id=TopBanner_UserPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href="usermain.jsp">User</A></TD>
																			<TD align=right width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="33%">
															<DIV class=header_active id=TopBanner_DomainPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href="domainmain.jsp">Domain</A></TD>
																			<TD width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="34%"></TD>
													<% } %>
													</TR>
													<TR>
														<TD colSpan=3>
															<TABLE border=0 cellPadding=2 cellSpacing=0 width="100%">
																<TBODY>
																	<TR class=blanktd>
																		<TD width="90%">Working in Domain : <domain:domaininfo domain_id="<%= domainid %>" /></TD>
																		
																	</TR>
																	<TR>
																		<TD bgColor=#330099 colSpan=2></TD>
																	</TR>
																</TBODY>
														</TABLE>
														</TD>
													</TR>
												</TBODY>
											</TABLE>
										</TD>
									</TR>
								</TBODY>
							</TABLE>
						</TD>
					</TR>
					<TR>
						<TD class=navbg><!--For the menu--><!--Menu for User-->
							<% if (user_reg.equals("tempid")) { %>
							<domain:domainmenutemp showCurrPage="11"></domain:domainmenutemp>
							<% } else { %>
								<domain:domainmenu showCurrPage="11"></domain:domainmenu>
							<% } %>
						</TD>
						<TD vAlign=top><!--Main Section(Add to Whitelist)-->
							<TABLE border=0 cellPadding=0 cellSpacing=2 width="100%">
								<TBODY>
									<TR class=2nd_grid_head>
										<TD vAlign=top>Add to Temp Users Registration Module</TD>
									</TR>
									<TR>
										<TD>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
													<TR>
														<TD class=generalbody>Valid for Months</TD>
														<TD align=left>	<SELECT class=combox id=AddUsr_cbovalidmonth name=cbovalidmonth onchange="fundate()"> 
														<option value=0>Choose Month</option>		
													    <option value=1>1</option>
														<option value=6>6</option>
														<option value=12>12</option>
														</SELECT>
														</TD>
													</TR>
													<TR>
														<TD class=generalbody-gray>SignUp Allowed Till</TD>
														<TD align=left class=generalbody-gray>
														<INPUT class=textinpt id=AddUsr_txttempid maxLength=50 name=txtsignup style="WIDTH: 250px" size="20">
														</TD>
													</TR>
													<TR>
														<TD class=generalbody>Number of Id's to Create</TD>
														<TD align=left class=generalbody>
														<INPUT class=textinpt id=AddUsr_txttemppwd maxLength=50 name=txtid style="WIDTH: 250px" size="20">
														</TD>
													</TR>
													<!--
													<TR>
														<TD class=generalbody-gray>Create Temp Id </TD>
														<TD align=left class=generalbody-gray>
														<INPUT class=textinpt id=AddUsr_txttempid maxLength=50 name=txttempid  readonly style="WIDTH: 250px" size="20">
														</TD>
													</TR>
													<TR>
														<TD class=generalbody>Create Temp Password </TD>
														<TD align=left class=generalbody>
														<INPUT class=textinpt id=AddUsr_txttemppwd maxLength=50 name=txttemppwd readonly style="WIDTH: 250px" size="20">
														</TD>
													</TR> -->
													<TR class=generalbody-gray>
														<TD vAlign=top width="30%">Send Email Report To</TD>
														<TD align=left colSpan=2 width="70%">
														<INPUT class=textinpt id=AddUsr_txtemail maxLength=50 name=txtemail style="WIDTH: 250px" size="20">&nbsp;
														
														</TD>
													</TR>
													
													
												</TBODY>
											</TABLE>
										</TD>
									</TR>
									<TR>
										<TD>
											
										</TD>
									</TR>
									<TR>
										<TD>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
																										
													<TR>
														<TD width="4%">&nbsp;</TD>
														<TD width="12%">&nbsp;</TD>
														<TD width="84%"><SPAN class=errmsg id=lblErr></SPAN></TD>
													</TR>
													<TR class=errmsg>
														<TD width="100%" colspan="3"><p align="center"><font size=2><%=message%></font></TD>
													</TR>
													<TR class=generalbody>
														<TD width="40%"></TD>
														<TD width="60%"><INPUT class=Btn name=btnSave type=submit value="Create Temp ID Now" onclick="chkValidation();return false"></TD>
													</TR>
												</TBODY>
											</TABLE>
										</TD>
									</TR>
								</TBODY>
							</TABLE>
						</TD>
					</TR>
				</TBODY>
			</TABLE>
			<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
				<TBODY>
					<TR>
						<TD bgColor=black colSpan=2 height=1 width="100%"></TD>
					</TR>
					<TR>
						<TD colSpan=2 width="100%">&nbsp;</TD>
					</TR>
					<TR>
						<TD align=middle class=footer colSpan=2 width="100%"><%@ include file= "includes/footer.htm" %></TD>
					</TR>
				</TBODY>
			</TABLE>
		</FORM>
	</BODY>
</HTML>
<%
}
%>