<%
/********************************************************************************/
/* Name			:	servercustomview.jsp										*/
/* Copyright	:	2003 SATCOMLABS LTD.										*/
/* Team			:	Spam Control Team											*/
/* Developer	:	Pavan Gupta													*/
/* Last Updated	:	AM 05/02/2004												*/
/* Abstract		:	Search Whitelist (AdminASL Table) by keyword or date		*/
/* Called from	: 	servermain													*/
/* Calls		:																*/
/********************************************************************************/
%>
<%@ page language="java" import ="java.util.Date,java.text.SimpleDateFormat,com.DBConnection,java.sql.*" %>
<%@ taglib prefix="spam" uri="/WEB-INF/TLDS/spamcontrollar.tld" %>
<%@ taglib prefix="domain" uri="/WEB-INF/TLDS/domain.tld" %>
<%@ taglib prefix="server" uri="/WEB-INF/TLDS/server.tld" %>
<%@ taglib prefix="utility" uri="/WEB-INF/TLDS/utility.tld" %>
<jsp:useBean id = "validate" scope="session" class="com.antispam.Authentication" />

<%
int userid = validate.getUserid();
int adminid = validate.getAdminid();
if(userid==0 || adminid!=1)
{
	response.sendRedirect("dashboardlogin.jsp");
}
else
{
	int allrecords = 0;
	int minpage = 0;
	int min = 1;
	int minimum = 1;
	
	int NumRec = 10;
	int preallrecords = 0;
	int preminpage = 0;
	int premin = 1;
	int preminimum = 1;

	String clicked = "";
	int spamallrecords = 0;
	int spamminpage = 0;
	int spammin = 1;
	int spamminimum = 1;

	int incr = 0;
	int i = 0;

	String gridclass = "";
	String dateFormat = "103";
	String datePtt = "[DD/MM/YYYY]";
	String dateForm = "dd/MM/yyyy";
	/******************************** Using DataBase connection for getting Date Setting ********/

	DBConnection dbconn = new DBConnection ();
	Connection conn = dbconn.getConnection();
	Statement stmt = conn.createStatement();
	ResultSet rs = stmt.executeQuery("Select date_format from admindefaults");
	rs.next();
	if(rs.getString("date_format").equalsIgnoreCase("MM/DD/YYYY"))
	{
		dateFormat = "101";
		datePtt = "[MM/DD/YYYY]";
		dateForm = "MM/dd/yyyy";
	}
	stmt.close();
	conn.close();
	
	/******************************** End of new DataBase code **********************************/
	SimpleDateFormat dateformat = new SimpleDateFormat(dateForm);
	String afterdate = dateformat.format(new Date());
	String beforedate = dateformat.format(new Date());
	String searchtext = "*";
	int policy = 0;
	int scope = 0;
	String flag1 = "false";
	String column_name = "";
	String order_by = "";
	

	if(request.getParameter("flag1") != null)
		flag1 = request.getParameter("flag1");
	if (request.getParameter("txtsearch") != null)
		searchtext = request.getParameter("txtsearch");
	if(request.getParameter("rdoPolicy") != null)
		policy = Integer.parseInt(request.getParameter("rdoPolicy"));
	if(request.getParameter("rdoScope") != null)
		scope = Integer.parseInt(request.getParameter("rdoScope"));
	if(request.getParameter("txtAfter") != null)
		afterdate = request.getParameter("txtAfter");
	if(request.getParameter("txtBefore") != null)
		beforedate = request.getParameter("txtBefore");
	if(request.getParameter("txtNumRec")!=null)
	NumRec = Integer.parseInt(request.getParameter("txtNumRec"));

	String updatetype = "";
	if(request.getParameter("update_type") != null)
		updatetype = request.getParameter("update_type");

	String message = "";
	String message1 = "";
	String message2 = "";
	if(request.getParameter("msg") != null)
	{
		if(updatetype.equals("updateany"))
			message = request.getParameter("msg");
		else if(updatetype.equals("updatepre"))
			message1 = request.getParameter("msg");
		else if(updatetype.equals("updatespam"))
			message2 = request.getParameter("msg");
	}

	String orderpre = "desc";
	String columnnamepre = "date_insersion";

	String orderspam = "desc";
	String columnnamespam = "date_insersion";

	if(request.getParameter("hidorderpre") != null)
		orderpre = request.getParameter("hidorderpre");
	if(request.getParameter("hidcolumnpre") != null)
		columnnamepre = request.getParameter("hidcolumnpre");

	if(request.getParameter("hidorderspam") != null)
		orderspam = request.getParameter("hidorderspam");
	if(request.getParameter("hidcolumnspam") != null)
		columnnamespam = request.getParameter("hidcolumnspam");

	if(policy==1)
	{
		column_name = columnnamepre;
		order_by = orderpre;
	}
	else if (policy==2)
	{
		column_name = columnnamespam;
		order_by = orderspam;
	}


	if(request.getParameter("hidpreminpage") != null  && !request.getParameter("hidpreminpage").equals(""))
			preminpage = Integer.parseInt(request.getParameter("hidpreminpage"));
	if(request.getParameter("hidpremin") != null  && !request.getParameter("hidpremin").equals(""))
			premin = Integer.parseInt(request.getParameter("hidpremin"));
	if(request.getParameter("hidpreminimum") != null && !request.getParameter("hidpreminimum").equals(""))
			preminimum = Integer.parseInt(request.getParameter("hidpreminimum"));


	if(request.getParameter("hidspamminpage") != null && !request.getParameter("hidspamminpage").equals(""))
		spamminpage = Integer.parseInt(request.getParameter("hidspamminpage"));
	if(request.getParameter("hidpremin") != null && !request.getParameter("hidpremin").equals(""))
		spammin = Integer.parseInt(request.getParameter("hidspammin"));
	if(request.getParameter("hidspamminimum") != null && !request.getParameter("hidspamminimum").equals("") )
			spamminimum = Integer.parseInt(request.getParameter("hidspamminimum"));

	if(request.getParameter("hidminpage") != null && !request.getParameter("hidminpage").equals(""))
		minpage = Integer.parseInt(request.getParameter("hidminpage"));
	if(request.getParameter("hidpremin") != null && !request.getParameter("hidpremin").equals(""))
		min = Integer.parseInt(request.getParameter("hidmin"));
	if(request.getParameter("hidminimum") != null && !request.getParameter("hidminimum").equals("") )
			minimum = Integer.parseInt(request.getParameter("hidminimum"));
	if(request.getParameter("hidclicked") != null)
		clicked = request.getParameter("hidclicked");
	
%>
<HTML>
	<HEAD>
		<TITLE>Search Whitelist</TITLE>
		<LINK href="stylesheets/display_control.css" rel=stylesheet type=text/css>
	</HEAD>
	<SCRIPT language=javascript src="scripts/web_uivalidation.js"></SCRIPT>
	<SCRIPT src="scripts/date-picker.js"></SCRIPT>
	<SCRIPT language=javascript src="scripts/validations.js"></SCRIPT>

	<script language=javascript>
	function load()
	{
		document.frmmain.txtsearch.focus();
		document.frmmain.rdoPolicy[<%=policy%>].checked=true;
		document.frmmain.rdoScope[<%=scope%>].checked=true;
	}

	// FOR ALL CLIENT SIDE VALIDATIONS
	function chkValidation()
	{
		afterdt = document.frmmain.txtAfter.value;
		beforedt = document.frmmain.txtBefore.value;

		/*afterdate = new Date(afterdt);
		beforedate = new Date(beforedt);*/

		var temp = new Array();
		temp = afterdt.split('/');
	
		fromdate = new Date(temp[1]+"/"+temp[0]+"/"+temp[2]);

		temp = beforedt.split('/');			
		todate = new Date(temp[1]+"/"+temp[0]+"/"+temp[2]);			


		if(isBlank(document.frmmain.txtsearch) == "1")
		{
			alert("Enter Keyword");
			document.frmmain.txtsearch.focus();
			return false;
		}
		// CHECK SPECIAL CHARACTERS
		/*else if(chkSearchText(document.frmmain.txtsearch.value) == "false") 
		{
			alert("Special Characters are not allowed");
			document.frmmain.txtsearch.value="";
			document.frmmain.txtsearch.focus();
			return false;
		}*/
		
		/*else if(afterdate > beforedate)
		{
			alert ("After date must be less than or equal to Before date");
			return false;
		}*/

		else if(Date.parse(fromdate) > Date.parse(todate))
		{
			alert ("After date must be less than or equal to Before date");
			return false;
		}

		else
		{
			document.frmmain.action= "servercustomview.jsp";
			document.frmmain.submit();
		}
	}

	// CHECK THAT AFTER DATE SHOULD BE LESS THAN BEFORE DATE
	function chkDate()
	{
		afterdt = document.frmmain.txtAfter.value;
		beforedt = document.frmmain.txtBefore.value;

		afterdate = new Date(afterdt);
		beforedate = new Date(beforedt);
		
		if (DateCompare(afterdate,beforedate) == 1)
		{
			alert ("After date must be less than or equal to Before date");
			return false;
		}
	}


	// SUBMIT THE PAGE FOR DELETE THE RECORDS AND ALSO CHECK THAT AT LEAST ONE RECORD SHOULD BE SELECTED
	function submitDelete(type)
	{
		//recordcount = document.frmmain.txtcount.value;
		if(type == "updateany")
			recordcount = document.frmmain.txtcount.value;
		else if(type == "updatepre")
			recordcount = document.frmmain.txtcount1.value-document.frmmain.txtmincount1.value;
		else if(type == "updatespam")
			recordcount = document.frmmain.txtcount2.value-document.frmmain.txtmincount2.value;

		if(recordcount == 0)
			alert ("No Record To Delete");
		else
		{
			var chkid = document.frmmain.chkdelete;
			var checked=false;
			if(recordcount == 1)
			{
				if(chkid.checked == 1)
					checked = true;
			}
			else if (recordcount > 1)
			{
				for(i=0; i<chkid.length; i++)
				{
					if(chkid[i].checked == 1)
					{
						checked=true;
						break;
					}
				}
			}
			if(checked==false)
				alert("Please check at least one record");
			else
			{
				document.frmmain.action = "editadminasl.jsp?flag=DELETE&val=selected&type="+type;
				document.frmmain.submit();
			}
		}
	}

	//FUNCTION TO UPDATE RECORDS
	function submitUpdate(type)
	{
		if(type == "updateany")
			recordcount = document.frmmain.txtcount.value;
		else if(type == "updatepre")
			recordcount = document.frmmain.txtcount1.value-document.frmmain.txtmincount1.value;
		else if(type == "updatespam")
			recordcount = document.frmmain.txtcount2.value-document.frmmain.txtmincount2.value;

		if(recordcount == 0)
			alert ("No Record To Update");
		else
		{
			document.frmmain.action = "editadminasl.jsp?flag=UPDATE&val=selected&type="+type;
			document.frmmain.submit();
		}
	}

	//FUNCTION TO SORT PRE-APPROVED SENDERS
	function sortPre(order,column)
	{
		document.frmmain.hidcolumnpre.value=column;
		document.frmmain.hidorderpre.value=order;
		document.frmmain.action="servercustomview.jsp";
		document.frmmain.submit();
	}

	//FUNCTION TO SORT SPAMMERS
	function sortSpam(order,column)
	{
		document.frmmain.hidcolumnspam.value=column;
		document.frmmain.hidorderspam.value=order;
		document.frmmain.action="servercustomview.jsp";
		document.frmmain.submit();
	}

	//FUNCTION TO SHOW NEXT 10 PAGES
	function changePage(pageno,min,pagingtype)
	{
		if(pagingtype == "all")
		{
			document.frmmain.hidminpage.value=pageno;
			document.frmmain.hidmin.value=min;
			document.frmmain.hidminimum.value=min;
		}
		else if(pagingtype == "pre")
		{
			document.frmmain.hidpreminpage.value=pageno;
			document.frmmain.hidpremin.value=min;
			document.frmmain.hidpreminimum.value=min;
		}
		else if(pagingtype == "spam")
		{
			document.frmmain.hidspamminpage.value=pageno;
			document.frmmain.hidspammin.value=min;
			document.frmmain.hidspamminimum.value=min;
		}
				document.frmmain.action="servercustomview.jsp";
			document.frmmain.submit();
	}

	//FUNCTION TO SHOW NEXT PAGE
	function Page(min,max,pagingtype)
	{
		if(pagingtype == "all")
		{
			document.frmmain.hidminimum.value=min;
			document.frmmain.hidclicked.value=pagingtype;
			document.frmmain.hidNumRec.value=10;
		}
		else if(pagingtype == "pre")
		{
			document.frmmain.hidclicked.value=pagingtype;
			document.frmmain.hidpreminimum.value=min;
			document.frmmain.hidNumRec.value=10;
		}
		else if(pagingtype == "spam")
		{
			document.frmmain.hidclicked.value=pagingtype;
			document.frmmain.hidspamminimum.value=min;
			document.frmmain.hidNumRec.value=10;
		}

		document.frmmain.action="servercustomview.jsp";
		document.frmmain.submit();
	}
	</script>

	<BODY onload="load()">
		<FORM method=post name=frmmain>
			<INPUT type=hidden name=flag1 value="true">
			<INPUT type=hidden class=textinpt name=hidcolumnpre value="<%=columnnamepre%>">
			<INPUT type=hidden class=textinpt name=hidorderpre value="<%=orderpre%>">
			<INPUT type=hidden class=textinpt name=hidcolumnspam value="<%=columnnamespam%>">
			<INPUT type=hidden class=textinpt name=hidorderspam value="<%=orderspam%>">

			<INPUT type="hidden" name="hidpreminpage" value=<%=preminpage%>>
			<INPUT type="hidden" name="hidpremin" value=<%=premin%>>
			<INPUT type="hidden" name="hidpreminimum" value=<%=preminimum%>>

			<INPUT type="hidden" name="hidspamminpage" value=<%=spamminpage%>>
			<INPUT type="hidden" name="hidspammin" value=<%=spammin%>>
			<INPUT type="hidden" name="hidspamminimum" value=<%=spamminimum%>>
			<INPUT type="hidden" name="hidclicked" value="<%=clicked%>">
			<INPUT type="hidden" name="hidNumRec" value="<%=NumRec%>">

			<INPUT type="hidden" name="hidminpage" value=<%=minpage%>>
			<INPUT type="hidden" name="hidmin" value=<%=min%>>
			<INPUT type="hidden" name="hidminimum" value=<%=minimum%>>

			<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
				<TBODY>
					<TR>
						<TD colSpan=2><!--for the header Image-->
							<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
								<TBODY>
									<TR>
										<TD bgColor=#cecece>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
													<TR>
														<TD align=left vAlign=top width="52%"><IMG src="images/img.gif" vspace=5 width="436" height="48"></TD>
														<TD align=right vAlign=top width="48%"><IMG src="images/topbar-right.gif" width="229" height="48"></TD>
													</TR>
												</TBODY>
											</TABLE>
										</TD>
									</TR>
									<TR>
										<TD bgColor=#000000><IMG src="images/1x1.gif" width="1" height="1"></TD>
									</TR>
									<TR>
										<TD align=left bgColor=#007ccd height=37 vAlign=bottom>
											<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
												<TBODY>
													<TR>
													<% if (adminid == 1) { %>
														<TD align=left vAlign=bottom width="33%">
															<DIV class=header id=TopBanner_UserPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href = "usermain.jsp">User</a></TD>
																			<TD align=right width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="33%">
															<DIV class=header id=TopBanner_Panel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href = "domainmain.jsp">Domain</A></TD>
																			<TD width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
														<TD width="34%">
															<DIV class=header_active id=TopBanner_ServerPanel>
																<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
																	<TBODY>
																		<TR>
																			<TD width=5><IMG src="images/tab-left.gif" width="5" height="17"></TD>
																			<TD align=middle style="FONT-SIZE: 12px; FONT-WEIGHT: bold"><A href = "servermain.jsp">Server</a></TD>
																			<TD width=5><IMG src="images/tab-right.gif" width="5" height="17"></TD>
																		</TR>
																	</TBODY>
																</TABLE>
															</DIV>
														</TD>
													<% } %>
												</TR>
											<TR>
												<TD colSpan=3>
													<TABLE border=0 cellPadding=2 cellSpacing=0 width="100%">
														<TBODY>
															<TR class=blanktd>
																<spam:UserInfo userid="<%= userid %>">
																	<TD width="90%">Logged in as: <%= username %>@<%=domainname%> on Server: <%=request.getServerName()%></TD>
																</spam:UserInfo>
																<TD align=right width="10%"><A class=gridrowlink href=javascript:onclick=openHelp('help/ServerCustomViewHelp.htm') style="FONT-SIZE: 10px; FONT-WEIGHT: bold">Help</A></TD>
															</TR>
															<TR>
																<TD bgColor=#330099 colSpan=2></TD>
															</TR>
														</TBODY>
													</TABLE>
												</TD>
											</TR>
										</TBODY>
									</TABLE>
								</TD>
							</TR>
						</TBODY>
					</TABLE>
				</TD>
			</TR>
			<TR>
				<TD class=navbg><!--For the menu--><!--Menu for User-->
					<server:servermenu showCurrPage="7" />
				</TD>
				<TD align=middle vAlign=top><!--Main Section-->
					<TABLE border=0 cellPadding=0 cellSpacing=2 width="100%">
						<TBODY>
							<TR>
								<TD>
									<TABLE border=0 cellPadding=0 cellSpacing=0 id=Table1 width="100%">
										<TBODY>
											<TR class=2nd_grid_head>
												<TD align=middle colSpan=2>Search Whitelist</TD>
											</TR>
											<TR class=viewall_links>
												<TD align=left colSpan=2>
													<a id="A1" href="serverviewall.jsp?conditionid=1">Pre-approved</a>&nbsp; 
													<a id="lnk1" href="serverviewall.jsp?conditionid=2">Spammers</a>&nbsp; Search
												</TD>
											</TR>
											<TR class=general_TR>
												<TD align=left colSpan=2>&nbsp;</TD>
											</TR>
											<TR class=general_TR>
												<TD align=left colSpan=2>Show all entries whose email address match: <INPUT class=textinpt name=txtsearch size=30 value="<%=searchtext%>"></TD>
											</TR>
											<TR class=general_TR>
												<TD align=left width="20%">And policy is:</TD>
												<TD align=left width="80%">
													<SPAN class=radio id=rdoPolicy>
														<INPUT CHECKED id=rdoPolicy name=rdoPolicy type=radio value=0>
														<LABEL for=rdoPolicy>Ignore Policy</LABEL>
														<INPUT id=rdoPolicy name=rdoPolicy type=radio value=1>
														<LABEL for=rdoPolicy>Pre-approved</LABEL>
														<INPUT id=rdoPolicy name=rdoPolicy type=radio value=2>
														<LABEL for=rdoPolicy>Spammer</LABEL>
													</SPAN>
												</TD>
											</TR>
											<TR class=general_TR>
												<TD align=left width="20%">And scope is:</TD>
												<TD align=left width="80%">
													<SPAN class=radio id=rdoScope>
														<INPUT CHECKED id=rdoScope name=rdoScope type=radio value=0>
														<LABEL for=rdoScope>Ignore Scope</LABEL>
														<INPUT id=rdoScope name=rdoScope type=radio value=1>
														<LABEL for=rdoScope>Email</LABEL>
														<INPUT id=rdoScope name=rdoScope type=radio value=2>
														<LABEL for=rdoScope>Domain</LABEL>
														<INPUT id=rdoScope name=rdoScope type=radio value=3>
														<LABEL for=rdoScope>Subdomains</LABEL>
													</SPAN>
												</TD>
											</TR>
											<TR class=general_TR>
												<TD align=left colSpan=2>And Date of Entry into Whitelist is:</TD>
											</TR>
											<TR class=general_TR>
												<TD align=left width="20%">After:</TD>
												<TD align=left vAlign=bottom width="80%">&nbsp;&nbsp;
													<INPUT class=textinpt id=txtAfter maxLength=10 name=txtAfter size=10 value="<%=afterdate%>" readonly>&nbsp;
													<A href="javascript:show_calendar('frmmain.txtAfter',<%=dateFormat%>);">
													<IMG align=middle alt="Click to Input Date" border=0 src="images/calendar.gif" width="16" height="14"></A>&nbsp;
													<FONT size=1><%=datePtt%></FONT>&nbsp;&nbsp;And before:&nbsp;
													<INPUT class=textinpt id=txtBefore maxLength=10 name=txtBefore size=10 value="<%=beforedate%>" readonly>&nbsp;
													<A href="javascript:show_calendar('frmmain.txtBefore',<%=dateFormat%>);">
													<IMG align=middle alt="Click to Input Date" border=0 src="images/calendar.gif" width="16" height="14"></A>&nbsp;
													<FONT size=1><%=datePtt%></FONT>
												</TD>
											</TR>
											<TR class=general_TR>
												<TD align=middle colSpan=2><INPUT class=btn name=cmdSearch type=submit value=Search onclick="chkValidation();return false">&nbsp;<A class=gridrowlink href=javascript:onclick=openHelp('help/SearchHelp.htm') style="FONT-SIZE: 10px; FONT-WEIGHT: bold">Help</A></TD>
											</TR>
											<TR>
												<TD align=middle bgColor=black colSpan=2 height=1></TD>
											</TR>
											<TR id=result>
												<TD align=middle colSpan=2 >
													<TABLE border=0 cellPadding=0 cellSpacing=0 id=Table1 width="100%">
														<TBODY>
															<TR>
																<TD align=middle colSpan=2 width="50%">&nbsp;</TD>
															</TR>
															<TR class=2nd_grid_head>
																<TD align=middle colSpan=2 width="50%"><SPAN id=lblPageHeader>Search Result</SPAN></TD>
															</TR>
															<TR>
																<TD align=middle colSpan=2 width="50%">&nbsp;</TD>
															</TR>
		            
<% 
															if (policy != 0)
															{
%>
<!-- VIEWING ALL PRE-APPROVED SENDERS/SPAMMERS -->
																<INPUT type=hidden name=txtmincount value=<%=incr%>>
																<TR>
																<TD>
																	<table cellspacing="0" cellpadding="1" rules="cols" border="1" id="preresultid" style="width:100%;border-collapse:collapse;">
																		<% if (policy==1) { %>
																			<TR id="preid" class="1stgrid_head" >
																				<TD align="center" colSpan="6">Pre-approved Senders</TD>
																			</TR>
																			<server:serversendersheader condition="<%=policy%>" orderpre="<%=orderpre%>" columnnamepre="<%=columnnamepre%>"></server:serversendersheader>
																		<% } else if(policy==2) { %>
																			<TR id="preid" class="1stgrid_head-spam" >
																				<TD align="center" colSpan="6">Spammers</TD>
																			</TR>
																			<server:serversendersheader condition="<%=policy%>" orderspam="<%=orderspam%>" columnnamespam="<%=columnnamespam%>"></server:serversendersheader>
																		<% } %>
																		<server:servercustomview condition_id = "<%=policy%>" searchtext="<%=searchtext%>" approval_id="<%=scope%>" afterdate="<%=afterdate%>" beforedate="<%=beforedate%>" column="<%=column_name%>" order="<%=order_by%>" minimum="<%=minimum%>">
<%
																		if(aslid.equals("0"))
																		{}
																		else
																		{
																			incr++; 
																			if (incr%2 != 0)
																				gridclass = "gridrow2";
																			else
																				gridclass = "gridrow1";
%>
																			<INPUT type="hidden" name="txtid" value="<%=aslid%>">
																			<tr class="<%=gridclass%>">
																				<td style="width:20%;"><%=mailerid%></td>
																				<td style="width:25%;"><%=mailerdomain%></td>
																				<td style="width:22%;"><%=dateofentry%></td>
<%	
																				if(Integer.parseInt(conditionid) == 1)
																				{
%>
																					<td nowrap="nowrap" align="Left" style="width:12%;"><input checked value="1" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'pre-approved'. All email from this sender is welcome." class="radio" />P<input value="2" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'spam' and reject all subsequent emails from this sender" class="radio" />S</td>
<%
																				}
																				else if(Integer.parseInt(conditionid) == 2)
																				{
%>
																					<td nowrap="nowrap" align="Left" style="width:12%;"><input  value="1" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'pre-approved'. All email from this sender is welcome." class="radio" />P<input checked value="2" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'spam' and reject all subsequent emails from this sender" class="radio" />S</td>
<%
																				}
																				if(Integer.parseInt(approvalid) == 1)
																				{
%>	
																					<TD><input checked title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																				}
																				else if(Integer.parseInt(approvalid) == 2)
																				{
%>
																					<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input checked title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																				}
																				else if(Integer.parseInt(approvalid) == 3)
																				{
%>
																					<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input checked title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																				}
%>
																				<TD align="center">
																				<input type="checkbox" name="chkdelete" value=<%=aslid%>>
																				</TD>
																			</tr>
<%
																		}
%>
																		<% allrecords = Integer.parseInt(countasl); %>
																		</server:servercustomview> 
																		<tr class="footer" align="Right">
																			<td colspan="7"><utility:paging totalrecords="<%=allrecords%>" minpage="<%=minpage%>" min="<%=min%>" pagingtype="all" 
																			txtNumRec="<%=NumRec%>"
																			clicked ="<%=clicked%>"/></td>
																		</tr>
																	</table>
																</TD>
															</TR>
														</TBODY>
													</TABLE>
													<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
														<TBODY>
															<TR>
																<TD align=middle height=7><font size=2 color=red><%=message%></font></TD>
															</TR>
															<TR>
																<TD align=middle>
																	<INPUT class=btn name=cmdSave type=submit value="Save Changes" onclick="submitUpdate('updateany'); return false">
																	<INPUT class=btn name=cmdDelete type=submit value="Delete Checked" onclick="submitDelete('updateany'); return false">
																</TD>
																<INPUT type=hidden name=txtcount value=<%=incr%>>
															</TR>
															<TR>
<%
															}
															else
															{
%>
<!-- VIEWING ALL PRE-APPROVED SENDERS -->
																<INPUT type=hidden  name=txtmincount1 value=<%=incr%>>
																<TR>
																	<TD>
																		<table cellspacing="0" cellpadding="1" rules="cols" border="1" id="preresultid" style="width:100%;border-collapse:collapse;">
																			<TR id="preid" class="1stgrid_head" >
																				<TD align="center" colSpan="6">Pre-approved Senders</TD>
																			</TR>
																			<server:serversendersheader condition="1" orderpre="<%=orderpre%>" columnnamepre="<%=columnnamepre%>"></server:serversendersheader>
																			<server:servercustomview condition_id ="1" searchtext="<%=searchtext%>" approval_id="<%=scope%>" afterdate="<%=afterdate%>" beforedate="<%=beforedate%>" column="<%=columnnamepre%>" order="<%=orderpre%>" minimum="<%=preminimum%>">
<%
																			if (aslid.equals("0"))
																			{}
																			else
																			{
																				incr++;
																				i++;
																				if (i%2 != 0)
																					gridclass = "gridrow2";
																				else
																					gridclass = "gridrow1";
%>
																				<INPUT type="hidden" name="txtid" value="<%=aslid%>">
																				<tr class="<%=gridclass%>">
																					<td style="width:20%;"><%=mailerid%></td>
																					<td style="width:25%;"><%=mailerdomain%></td>
																					<td style="width:22%;"><%=dateofentry%></td>
																					<td nowrap="nowrap" align="Left" style="width:12%;">
																						<input checked value="1" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'pre-approved'. All email from this sender is welcome." class="radio" />P<input value="2" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'spam' and reject all subsequent emails from this sender" class="radio" />S
																					</td>
<%	
																					if(Integer.parseInt(approvalid) == 1)
																					{
%>	
																						<TD><input checked title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
																					else if(Integer.parseInt(approvalid) == 2)
																					{
%>
																						<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input checked title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
																					else if(Integer.parseInt(approvalid) == 3)
																					{
%>
																						<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input checked title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
%>
					  
																					<TD align="center">
																					<input type="checkbox" name="chkdelete" value=<%=aslid%>>
																					</TD>
																				</tr>
<%
																			}
%>
																			<% preallrecords = Integer.parseInt(countasl); %>
																			</server:servercustomview> 
																			<tr class="footer" align="Right">
																				<td colspan="7"><utility:paging totalrecords="<%=preallrecords%>" minpage="<%=preminpage%>" min="<%=premin%>" pagingtype="pre" txtNumRec="<%=NumRec%>"
																				clicked ="<%=clicked%>"/></td>
																			</tr>
																		</table>
																	</TD>
																</TR>
															</TBODY>
														</TABLE>
														<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
															<TBODY>
																<TR>
																	<TD align=middle height=7><font size=2 color=red><%=message1%></font></TD>
																</TR>
																<TR>
																	<TD align=middle>
																		<INPUT class=btn name=cmdSave type=submit value="Save Changes" onclick="submitUpdate('updatepre'); return false">
																		<INPUT class=btn name=cmdDelete type=submit value="Delete Checked" onclick="submitDelete('updatepre'); return false">
																	</TD>
																	<INPUT type=hidden  name=txtcount1 value=<%=incr%>>
																</TR>
																<TR>
																	<TD>&nbsp;</TD>
																</TR>
<% i = 0; %>
<!--VIEWING  ALL SPAMMERS -->
																<INPUT type=hidden name=txtmincount2 value=<%=incr%>>
																<TR>
																	<TD>
																		<table cellspacing="0" cellpadding="1" rules="cols" border="1" id="spamresultid" style="width:100%;border-collapse:collapse;">
																			<TR id="spamid" class="1stgrid_head-spam">
																				<TD align="center" colSpan="6">Spammers</TD>
																			</TR>
																			<server:serversendersheader condition="2" orderspam="<%=orderspam%>" columnnamespam="<%=columnnamespam%>"></server:serversendersheader>
																			<server:servercustomview condition_id="2" searchtext="<%=searchtext%>" approval_id="<%=scope%>" afterdate="<%=afterdate%>" beforedate="<%=beforedate%>" column="<%=columnnamespam%>" order="<%=orderspam%>" minimum="<%=spamminimum%>">

<%
																			if(aslid.equals("0"))
																			{}
																			else
																			{
																				incr++;
																				i++;
																				if (i%2 != 0)
																					gridclass = "gridrow2";
																				else
																					gridclass = "gridrow1-spam";
%>
																				<INPUT type="hidden" name="txtid" value="<%=aslid%>">
																				<TR class = <%=gridclass%>>
																					<TD><%=mailerid%></TD>
																					<TD><%=mailerdomain%></TD>
																					<TD><%=dateofentry%></TD>
																					<td nowrap="nowrap" align="Left" style="width:12%;">
																						<input  value="1" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'pre-approved'. All email from this sender is welcome." class="radio" />P<input checked value="2" name="optpolicy<%=incr%>" type="radio" title="Make this email address 'spam' and reject all subsequent emails from this sender" class="radio" />S
																					</td>
 <%	
																					if(Integer.parseInt(approvalid) == 1)
																					{
%>	
																						<TD><input checked title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
																					else if(Integer.parseInt(approvalid) == 2)
																					{
%>
																						<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input checked title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
																					else if(Integer.parseInt(approvalid) == 3)
																					{
%>
																						<TD><input title="Apply policy to this email address only"type = "radio" name = "optscope<%=incr%>" value="1">E<input title="Apply policy to the entire domain (organization)" type = "radio" name = "optscope<%=incr%>" value="2">D<input checked title="Apply policy to the domain AND any subdomains" type=radio type = "radio" name = "optscope<%=incr%>" value="3">S</TD>
<%
																					}
%>
																					<TD align="center">
																						<input type="checkbox" name="chkdelete" value=<%=aslid%>>
																					</TD>
																				</TR>
<%
																			}
%>		
																			<% spamallrecords = Integer.parseInt(countasl); %>
																			</server:servercustomview> 
																			<tr class="footer" align="Right">
																				<td colspan="7"><utility:paging totalrecords="<%=spamallrecords%>" minpage="<%=spamminpage%>" min="<%=spammin%>" pagingtype="spam" txtNumRec="<%=NumRec%>"
																				clicked ="<%=clicked%>"/></td>
																			</tr>
																		</table>
																	</TD>
																</TR>
															</TBODY>
														</TABLE>
														<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
															<TBODY>
																<TR>
																	<TD align=middle height=7><font size=2 color=red><%=message2%></font></TD>
																</TR>
																<TR>
																	<TD align=middle>
																		<INPUT class=btn name=cmdSave type=submit value="Save Changes" onclick="submitUpdate('updatespam'); return false">
																		<INPUT class=btn name=cmdDelete type=submit value="Delete Checked" onclick="submitDelete('updatespam'); return false">
																	</TD>
																	<INPUT type=hidden name=txtcount2 value=<%=incr%>>
																</TR>
<%
															}
%>
															</TR>
														</TBODY>
													</TABLE>
												</TD>
											</TR>
										</TBODY>
									</TD>
								</TR>
								<script>
									var flag1 = '<%=flag1%>'
									if (flag1 == "false")
										result.style.display = 'none';
									else if (flag1 == "true")
										result.style.display = '';
								</script>
							</TBODY>
						</TABLE>
					</TD>
				</TR>
			</TBODY>
		</TABLE>
	</TD>
</TR>
</TBODY>
</TABLE>
			<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
				<TBODY>
					<TR>
						<TD bgColor=black colSpan=2 height=1 width="100%"></TD>
					</TR>
					<TR>
						<TD colSpan=2 width="100%">&nbsp;</TD>
					</TR>
					<TR>
						<TD align=middle class=footer colSpan=2 width="100%"><%@ include file= "includes/footer.htm" %></TD>
					</TR>
				</TBODY>
			</TABLE>
		</FORM>
	</BODY>
</HTML>
<%
}
%>